procedure hrifits(obsfile,fitsfile)

string obsfile {prompt="Input obs.tab from qpsec",mode="ql"}
string fitsfile{prompt="Name of output OGIP pha file", mode="ql"}

# Script to create an xspec pha file conforming to OGIP FITs format.
# The input file is an "_obs.tab" file from qpspec.  The whole file
# name (including .tab extension) must be specified.  The output file 
# is prompted for, and a file with "_pha.fits" appended is created.
# The script uses fcreate to write the fits file.  The files "fitscol"
# and "head" are hard-wired, and must be in the directory in which the
# script is run..  These are the column descriptor file and
# header keyword template required by fcreate.  The name of the
# response and arf files ( hri_dtmat_15.fits and hri_arf.fits) are
# hard-wired into the file "head".

begin
string obs,fits,obstemp,temphead
real ltime

obs=obsfile
fits=fitsfile
temphead=mktemp("temp_head")
obstemp=mktemp("obs_temp")

print("printing obs file from qpspec")

tprint(columns="cts_tot neterr",table=obs,showhdr=no,showrow=yes,> obstemp)

print("create initial fits file from ASCII dump of obs table")
fcreate(cdfile="fitscol",datafile=obstemp,outfile=fits//"_pha.fits",headfile="head")

print("Insert exposure time")

keypar(input=obs,keyword="LIVETIME")

ltime=real(keypar.value)

print("EXPOSURE ",ltime, > temphead)
fmodhead(infile=fits//"_pha.fits[1]",tmpfil=temphead)

print("remove temporary files")

#delete(files=temphead)
#delete(files=obstemp)
end 


