From eric@cfa242.harvard.edu Thu Mar 18 15:53:17 1993
Return-Path: <eric@cfa242.harvard.edu>
Received: from cfa242.harvard.edu by cfa267.harvard.edu (4.1/SMI-4.1)
	id AA29621; Thu, 18 Mar 93 15:53:16 EST
Received: by cfa242.harvard.edu (4.1/SMI-4.1)
	id AA02351; Thu, 18 Mar 93 15:53:14 EST
From: eric@cfa242.harvard.edu (Eric Mandel)
Message-Id: <9303182053.AA02351@cfa242.harvard.edu>
To: john@cfa242.harvard.edu
Subject: ptest.c
Date: Thu, 18 Mar 93 15:53:13 EST
Status: R


We need a simple ptest.c program that people can use as an example,
not a real test bed, but just an example.  I wrote one for Patricia
Monger and will send it and its param file along.  Can you add it to
your Param directory and put a line in the Makefile to compile it
(need not be part of PROGS, however).

Eric

From eric@cfa242.harvard.edu Thu Mar 18 15:53:44 1993
Return-Path: <eric@cfa242.harvard.edu>
Received: from cfa242.harvard.edu by cfa267.harvard.edu (4.1/SMI-4.1)
	id AA29626; Thu, 18 Mar 93 15:53:43 EST
Received: by cfa242.harvard.edu (4.1/SMI-4.1)
	id AA02356; Thu, 18 Mar 93 15:53:42 EST
From: eric@cfa242.harvard.edu (Eric Mandel)
Message-Id: <9303182053.AA02356@cfa242.harvard.edu>
To: john@cfa242.harvard.edu
Subject: ptest.c
Date: Thu, 18 Mar 93 15:53:41 EST
Status: R


/*
 *
 * test.c - simple use of the param interface
 *
 */

#include <stdio.h>
/* this is the include file for the parameter interface */
#include <parameter.h>

#define SZ_LINE 160

main(argc, argv)
     int argc;
     char **argv;
{
  char iname[SZ_LINE];			/* input ASCII file name */
  char eventdef[SZ_LINE];		/* PROS event definition */
  char mission[SZ_LINE];		/* mission (e.g. "AXAF") */
  char instrument[SZ_LINE];		/* instrument (e.g. "HRC") */
  char *progname;			/* program name */

  int xdim, ydim;			/* detector dimensions */
  int block;				/* default block factor for IMIO */
  int clobber;				/* clobber existing output? */
  paramfile pf;				/* parameter file handle */

  progname = argv[0];
  /* open the parameter file for this program */
  if( (pf = paramopen(progname, argv, argc, "rw")) == NULL ){
    fprintf(stderr, "Can't open parameter file '%s'\n", progname);
    exit(1);
  }
  /* get parameters */
  pgetstr(pf, "input", iname, SZ_LINE);
  pgetstr(pf, "eventdef", eventdef, SZ_LINE);
  pgetstr(pf, "mission", mission, SZ_LINE);
  pgetstr(pf, "instrument", instrument, SZ_LINE);
  /* dimensions of the detector */
  xdim = pgeti(pf, "xdim");
  ydim = pgeti(pf, "ydim");
  /* default block for imio */
  block = pgeti(pf, "block");
  clobber = pgetb(pf, "clobber");
  paramclose(pf);

  fprintf(stdout, "iname=%s, eventdef=%s, mission=%s, instrument=%s\n",
	  iname, eventdef, mission, instrument);

  fprintf(stdout, "xdim=%d, ydim=%d, block=%d, clobber=%d\n",
	  xdim, ydim, block, clobber);

}

From eric@cfa242.harvard.edu Thu Mar 18 15:54:01 1993
Return-Path: <eric@cfa242.harvard.edu>
Received: from cfa242.harvard.edu by cfa267.harvard.edu (4.1/SMI-4.1)
	id AA29630; Thu, 18 Mar 93 15:54:00 EST
Received: by cfa242.harvard.edu (4.1/SMI-4.1)
	id AA02361; Thu, 18 Mar 93 15:53:59 EST
From: eric@cfa242.harvard.edu (Eric Mandel)
Message-Id: <9303182053.AA02361@cfa242.harvard.edu>
To: john@cfa242.harvard.edu
Subject: ptest.par
Date: Thu, 18 Mar 93 15:53:58 EST
Status: R


input,s,a,"foo",,,"input ASCII file"
mission,s,a,"AXAF",AXAF|ASTROD,,"mission"
instrument,s,a,"ACIS",HRC|ACIS,,"instrument"
block,i,a,4,0,32,"default block factor for imio"
eventdef,s,h,"{s:x,s:y,s:pha,s:pi,d:time}",,,"event record definition"
xdim,i,h,16384,,,"detector x dimension"
ydim,i,h,16384,,,"detector y dimension"
clobber,b,h,yes,,,"delete old copy of output file"
mode,s,h,"ql",,,

