/* boolean.c
**/

#include <string.h>

#include "pfile.h"


static void *String2Bool(), *Real2Bool(), *Int2Bool();

static Converter Converters[] = {
	{StringType,	BooleanType,  String2Bool}, 
	{RealType,	BooleanType,  Real2Bool},
	{IntegerType,	BooleanType,  Int2Bool},
	{NULL,		NULL,   	NULL}
};


vtype booleanRec = {
	"b",
	Converters,

	VXSize,
	VXAcce,
	NULL
};

static void	*String2Bool(value, copy)
			char	*value;
			bool	*copy;
{
	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	     if ( !strcmp(value, "n") )		*copy = 0;
	else if ( !strcmp(value, "no") )	*copy = 0;
	else if ( !strcmp(value, "y") )		*copy = 1;
	else if ( !strcmp(value, "ye") )	*copy = 1;
	else if ( !strcmp(value, "yes") )	*copy = 1;
	else {
		parerr = PARCANTCONVERT;
		return NULL;
	}

	return copy;
}


static void  *Int2Bool(value, copy)
			int	*value;
			bool	*copy;
{
	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	*copy = *value != 0;

	return copy;
}

static void *Real2Bool(value, copy)
			real	*value;
			bool	*copy;
{
	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	*copy = *value != 0;

	return copy;
}








