.\" @(#)pget.l 0.1 91/09/01 AXAF Science Center; IRAF host interface
.TH PGET L "23 November 1991"
.SH NAME
pget \- get the value of one or more parameters in an IRAF-style parameter file
.SH SYNOPSIS
.B pget paramfile
[ 
.IR param1 .\|.\|.
]
.SH DESCRIPTION
.LP
.B pget
gets the values of parameters in the specified
.I paramfile
and outputs them on the standard output.
The values are separated by new-lines.
Thus,
.IP
.B
example% pget src region qpoe
.LP
will return:
.nf

	/pros/xray_old/data/snr.qp
	c 512 512 50

.fi
The pget program can be used, for example, in conjunction with the unix
back-quote facility to control the action of scripts.  For example:
.nf

	if (`pget scriptpars doit` == "yes") then
		echo "doing it ..."
		doit
	else
		echo "not doing it ..."
	endif
.fi
.LP
In searching for the parameter file,
.I .par
extension will be added to the
.I paramfile
name, if no extension is specified.
If the file is not located in the directory specified by the
.I paramfile,
the directory pointed to by the
.B UPARM
environment variable will be searched.
.SH OPTIONS
.TP
.B none
.SH ENVIRONMENT
.LP
The environment variable
.BR \s-1UPARM\s0
specifies the directory in which to look for the parameter
file, if the pathname of the file is not part of the
.I paramfile
specification.
.br
.ne 5
.SH "SEE ALSO"
.BR plist (l),
.BR pset (l),
.BR pquery (l),
.BR OpenParamFile (l),
.BR CloseParamFile (l),
.BR InitParamFile (l),
.BR AccessParam (l),
.BR GetParam (l),
.BR PutParam (l),
.BR param (l)
.SH NOTES
.LP
.SH AUTHOR
The original IRAF parameter interface was developed by the IRAF
development group at NOAO, led by Doug Tody.
.br
Eric Mandel and John Roll (SAO) developed the IRAF-compatible host interface.
