.\" @(#)plist.l 0.1 91/09/01 AXAF Science Center; IRAF host interface
.TH PLIST L "23 November 1991"
.SH NAME
plist \- list parameters from one or more IRAF-style parameter files
.SH SYNOPSIS
.B plist
[ 
.IR paramfile1 .\|.\|.
]
.SH DESCRIPTION
.LP
.B plist
displays the parameters from each
.I paramfile
in sequence on the standard output.  Thus:
.IP
.B
example% plist src
.LP
displays the contents of the
.B src
parameter file on the standard output:
.nf

Parameters for 'src' contained in '/home/eric/uparm/src.par':

         qpoe = "/pros/qpoe/small.qp" QPOE file
      (region = "c 512 512 100") region descriptor
        (mode = "ql")           

.fi
.LP
The display is nearly identical to the IRAF command
.B lparam.
As in the IRAF command, hidden parameters are displayed in parenthesis.
.LP
A
.I .par
extension will be added to the
.I paramfile
name, if no extension is specified.
If the file is not located in the directory specified by the
.I paramfile,
the directory pointed to by the
.B UPARM
environment variable will be searched.
.SH OPTIONS
.TP
.B none
.SH ENVIRONMENT
.LP
The environment variable
.BR \s-1UPARM\s0
specifies the directory in which to look for the parameter
file, if the pathname of the file is not part of the
.I paramfile
specification.
.br
.ne 5
.SH "SEE ALSO"
.BR pget (l),
.BR pset (l),
.BR pquery (l),
.BR OpenParamFile (l),
.BR CloseParamFile (l),
.BR InitParamFile (l),
.BR AccessParam (l),
.BR GetParam (l),
.BR PutParam (l),
.BR param (l)
.SH NOTES
.LP
.SH AUTHOR
The original IRAF parameter interface was developed by the IRAF
development group at NOAO, led by Doug Tody.
.br
Eric Mandel and John Roll (SAO) developed the IRAF-compatible host interface.
