.\" @(#)pquery.l 0.1 91/09/01 AXAF Science Center; IRAF host interface
.TH PQUERY L "23 November 1991"
.SH NAME
pquery \- get the value of a parameter in an IRAF-style parameter file, with
possible prompting
.SH SYNOPSIS
.B pquery paramfile param
[ 
.IR passign .\|.\|.
]
.SH DESCRIPTION
.LP
.B pquery
gets the value of the
.I param
parameter in the specified
.I paramfile
and outputs it on the standard output.
If the parameter is found in the
.IR passign
list, the value is taken from the list. If the parameter is not found
in the list, a query is generated on stderr for the parameter.  In
either case, the new value of the parameter is updated in the parameter
file.  
.LP
Thus,
.IP
.B
example% pquery src region
.LP
will result in the query:
.IP
region (c 512 512 100): c 512 512 50
.LP
The input string will be returned on stdout:
.IP
c 512 512 50
.LP
On the other hand, if a region value is already placed on the command line:
.IP
.B
example% pquery src region region="c 512 512 
.LP
no query is generated and the value is returned on stdout:
.IP
c 512 512 50
.LP
The pquery program is nearly always used in scripts.  A script is run
in which the input consists of various parameter assignments.  One or
more pquery's are run within the script to retrieve the value of
various parameters.  The parameter assignments input on the command
line are passed to each invocation of the pquery program.  If the user
has input a value for the parameter being retrieved on the command line,
the user-input value is returned.  Otherwise a query is generated on
stderr for the parameter. For example,
.nf

	if (`pquery scriptpars doit $*` == "yes") then
		echo "doing it ..."
		doit
	else
		echo "not doing it ..."
	endif
.fi
.LP
In this example, if the user runs the script by inputting the "doit"
parameter, its value is returned and no query is generated.  Otherwise,
the user will be queried for a value for that parameter.  In either
case, the value is updated into the scriptpars parameter file.
.LP
In searching for the parameter file,
.I .par
extension will be added to the
.I paramfile
name, if no extension is specified.
If the file is not located in the directory specified by the
.I paramfile,
the directory pointed to by the
.B UPARM
environment variable will be searched.
.SH OPTIONS
.TP
.B none
.SH ENVIRONMENT
.LP
The environment variable
.BR \s-1UPARM\s0
specifies the directory in which to look for the parameter
file, if the pathname of the file is not part of the
.I paramfile
specification.
.br
.ne 5
.SH "SEE ALSO"
.BR plist (l),
.BR pset (l),
.BR pget (l),
.BR OpenParamFile (l),
.BR CloseParamFile (l),
.BR InitParamFile (l),
.BR AccessParam (l),
.BR GetParam (l),
.BR PutParam (l),
.BR param (l)
.SH NOTES
.LP
.SH AUTHOR
The original IRAF parameter interface was developed by the IRAF
development group at NOAO, led by Doug Tody.
.br
Eric Mandel and John Roll (SAO) developed the IRAF-compatible host interface.
