.\" @(#)pset.l 0.1 91/09/01 AXAF Mission Support Team; Parameter Interface
.TH PSET L "23 November 1991"
.SH NAME
pset \- set one or more parameters in an IRAF-style parameter file
.SH SYNOPSIS
.B pset paramfile
[ 
.IR passign1 .\|.\|.
]
.SH DESCRIPTION
.LP
.B pset
sets parameters in the specified
.I paramfile.
The \fBpassign\fP arguments can be either \fBpositional\fP or \fBabsolute\fP
assignments.  Positional assignments consist of the value alone and
are assigned one to one to the corresponding non-hidden parameter in
the param file.  The \fBabsolute\fP or \fBkeyword\fP form is an
assignment, \fIparameter \(eq value\fP, where the parameter can be any
parameter of the program being run.  Here, order is not relevant.  (See
the \fBparam\fP man page for more information).
.PP
If no parameter assignments are specified, the user is prompted for a
new value for each parameter in the parameter file.  Both hidden and
non-hidden parameters are prompted for.  The default value is
displayed in parenthesis. The user can input a new value or a carriage
return to keep the default value.
.PP
If a parameter name is input in the command line followed immediately
by the "!" character (no spaces), that parameter is prompted for.
Again, the default value is displayed in parenthesis. The user can
input a new value or a carriage return to keep the default value.
.PP
Thus,
.IP
.B
example% pset src
.LP
will prompt for each parameter in the src parameter file:
.nf
	QPOE file (/pros/xray_old/data/snr.qp):
	region (c 512 512 100): c 512 512 50
	mode (ql):
.fi
.LP
The region parameter can also be changed directly:
.IP
example% pset src region="c 512 512 50"
.LP
Finally, we can prompt specifically for the region parameter alone:
.IP
example% pset src region!
.IP
region (c 512 512 100): c 512 512 50
.LP
In searching for the parameter file,
.I .par
extension will be added to the
.I paramfile
name, if no extension is specified.
If the file is not located in the directory specified by the
.I paramfile,
the directory pointed to by the
.B UPARM
environment variable will be searched.
.SH OPTIONS
.TP
.B none
.SH ENVIRONMENT
.LP
The environment variable
.BR \s-1UPARM\s0
specifies the directory in which to look for the parameter
file, if the pathname of the file is not part of the
.I paramfile
specification.
.br
.ne 5
.SH "SEE ALSO"
.BR pget (l),
.BR plist (l),
.BR pquery (l),
.BR OpenParamFile (l),
.BR CloseParamFile (l),
.BR InitParamFile (l),
.BR AccessParam (l),
.BR GetParam (l),
.BR PutParam (l),
.BR param (l)
.SH NOTES
.LP
.SH AUTHOR
The original IRAF parameter interface was developed by the IRAF
development group at NOAO, led by Doug Tody.
.br
Eric Mandel and John Roll (SAO) developed the IRAF-compatible host interface.
