/* f77.c
**
**
**
**/
#include <stdlib.h>

#define MAX_ARGC	 512
#define MAX_LINE	4096

static int      F77argc;
static char   **F77argv = 0;

#define CStringLength	1024

char            CString1[CStringLength];
char            CString2[CStringLength];

char           *strf2c(length, string, cstring)
    int             length;
    char           *string;
    char           *cstring;
{
    while (length && string[--length] == ' ');
    if (string[length] != ' ')
	length++;

    bcopy(string, cstring, length);
    cstring[length] = '\0';

    return cstring;
}

void            strc2f(cstring, fstring, length)
    char           *cstring;
    char           *fstring;
    int             length;
{
    int             i;

    /* Copy the C string, then padd with ' ' */
    for (i = 0; *cstring; i++)
	*fstring++ = *cstring++;
    for (; i < length; i++)
	*fstring++ = ' ';
}

#ifdef vms

#include jpidef.h
#include descrip.h

#include ctype.h

char          **GetF77argv(argc)
    int            *argc;
{

    int             request = JPI$_IMAGNAME;
    int             length;
    char            buffer[MAX_LINE + 1];
    int             i;

    struct dsc$descriptor_s line = {
	MAX_LINE, DSC$K_DTYPE_T, DSC$K_CLASS_S, buffer
    };

    if (F77argv) {
	*argc = F77argc;
	return F77argv;
    }
    F77argv = malloc(sizeof(char *) * MAX_ARGC);

    /* Get Job Process Information - Image Name */
    length = MAX_LINE;
    lib$getjpi(&request, NULL, NULL, NULL, &line, &length);
    buffer[length] = '\0';

    F77argv[0] = malloc(length + 1);
    strcpy(F77argv[0], buffer);

    /* Get Foriegn command line test */
    length = MAX_LINE;
    lib$get_foreign(&line, 0, &length);
    buffer[length] = '\0';

    for (i = 0; i < length; i++)
	if (isupper(buffer[i]))
	    buffer[i] = tolower(buffer[i]);

    F77argv[1] = malloc(length + 1);
    strcpy(F77argv[1], buffer);

    F77argc = *argc
	= parsline(F77argv[1], length, &F77argv[1], MAX_ARGC)
	+ 1;
    F77argv = realloc(F77argv, sizeof(char *) * F77argc);

    return F77argv;
}

static int      parsline(buffer, nbuf, column, ncol)
    char           *buffer;
    int             nbuf;
    char          **column;
    int             ncol;
{
    int             i, j;

    if (!nbuf)
	return 0;

    for (i = 0, j = 0; i < nbuf && j <= ncol; j++) {
	column[j] = &buffer[i];

	while (buffer[i] != ' '
		&& buffer[i] != '\t'
		&& buffer[i] != '\0'
		&& i < nbuf)
	    i++;

	if (buffer[i] == '\0')
	    break;
	buffer[i++] = '\0';
    }

    buffer[i] = '\0';
    column[j + 1] = &buffer[i + 1];

    return j + 1;
}

/* Fake the normal unix command line access for any interested parties

   NAME
	getarg, iargc - get the kth command line argument
   SYNOPSIS
     subroutine getarg ( k, arg )
     character*(*) arg

     function iargc ()

   DESCRIPTION
     The statement call getarg( k  ,  arg  )  will  get  the  kth
     command-line argument and put it into arg .

     The 0th argument is the command name.

     The function iargc returns the index of  the  last  command-
     line argument, and therefore the number  of  arguments  after
     the  command name.
**/

void            getarg(k, arg)
    int            *k;
    struct dsc$descriptor_d *arg;
{
    int             argc;
    char          **argv;

    if (!F77argv)
	argv = GetF77argv(&argc);

    strc2f(argv[*k], arg->dsc$a_pointer, arg->dsc$w_length);
}

int             iargc()
{
    int             argc;
    char          **argv;

    if (!F77argv)
	argv = GetF77argv(&argc);

    return argc - 1;
}

#else

char          **GetF77argv(argc)
    int            *argc;
{
    int             i;

    if (F77argv) {
	*argc = F77argc;
	return F77argv;
    }
    F77argv = malloc(sizeof(char *) * MAX_ARGC);

    *argc = F77argc = iargc_() + 1;

    for (i = 0; i < F77argc; i++) {
	F77argv[i] = malloc(MAX_LINE);
	getarg_(&i, F77argv[i], MAX_LINE);
	strf2c(MAX_LINE, F77argv[i], F77argv[i]);
	F77argv[i] = (char *) realloc(F77argv[i]
					 ,strlen(F77argv[i]) + 1);
    }

    F77argv = (char **) realloc(F77argv, sizeof(char *) * i);

    return F77argv;
}

#endif
