
%s NAMED
%s VALED

N	[a-zA-Z$][a-zA-Z0-9$_.]+
XV	[^\001]+
KV	[^\001=]+
SP	[\001]

%{

#include <string.h>
#include <stdlib.h>

#include "pfile.h"
#include "pargs.h"
#include "iarg.h"

extern int t_valu;

/* default iargwrap function - always treat EOF as an EOF */
#define iargwrap() 1

#define StrCpy(res, str, len)	( strncpy((res=malloc(len + 1)), str, len),\
					res[len] = '\0', res)

#undef  YY_INPUT
#define YY_INPUT(buf,result,max_size)	{				\
		if ( *buf = ArgvChar(((ArgStream) yyin)) )		\
			result = 1;					\
		else							\
			result = YY_NULL;				\
	}

%}


%%

{N}/[+-]{SP} 	{ /* Match a shortcut boolean assignment
		  ** The [+-] must be contigious to the name.
		  **/
			StrCpy(yylval.stri, yytext, yyleng);
			BEGIN(NAMED);
			return T_name;
		}
{N}/{SP}*[=]	{ /* Normal <name> = <value>
		  **/
			StrCpy(yylval.stri, yytext, yyleng);
			BEGIN(NAMED);
			return T_name;
		}
\=		{ /* Snag the assignment.
		  ** Note that positional parameters are done.
		  **/
			t_valu = T_valu;
			BEGIN(VALED);
			return '=';
		}
<NAMED>\+	{
			StrCpy(yylval.stri, "yes", 3);
			BEGIN(0);
			return T_mark;	}
<NAMED>\-	{
			StrCpy(yylval.stri, "no",  2);
			BEGIN(0);
			return T_mark;	}
{KV}(\[{XV}\])*	{ /* A normal value (= not allowed, except in [])
		  **/
                        if ( yyleng == 2 && !strncmp(yytext, "\"\"", 2) )
                          StrCpy(yylval.stri, "", 0);
                        else
                          StrCpy(yylval.stri, yytext, yyleng);

			BEGIN(0);
			return t_valu;
		}

<VALED>{XV}	{
			StrCpy(yylval.stri, yytext, yyleng);
			BEGIN(0);
			return T_valu;
		}

{SP}*		{
			BEGIN(0);
		}

