

%s NAME TYPE VALUE LINE
%s DQUOTE SQUOTE


WORD    [^, \t\n]*
VALU    [^,\"\'\n]*
DVAL	[^\\\"]*
SVAL	[^\\\']*


%{
/* iparlex.l
**/

#include <stdlib.h>
#include <string.h>

#include "pfile.h"
#include "ipar.h"

static char yystring[SZ_PFLINE];

extern yylineno;

/* default iparwrap function - always treat EOF as an EOF */
#define iparwrap() 1

#define StrCpy(res, str, len)	( strncpy((res=malloc(len + 1)), str, len),\
					res[len] = '\0', res)

/* This array and the field variable to cycle through the  context dependence
** of the current field that is expected.
**/
int	yyfields[7] = { NAME, TYPE, NAME, VALUE, VALUE, VALUE, VALUE };
int	yyfield = 0;


#define YY_USER_INIT	{ BEGIN(yyfields[yyfield = 0]);		}
/**
#define YY_USER_ACTION  { printf("field = %d, state = %d\n", yyfield, yy_start); }
**/

#define P(x)	printf(x)

#undef  YY_INPUT
#define YY_INPUT(buffer, result, max)					\
	{								\
		result = fread(buffer, 1, max, (FILE *)yyin);	\
	}

%}


%%
<TYPE>struct       {	StrCpy(yylval.stri, yytext, yyleng);	return T_struct;	}
<TYPE,NAME>{WORD} {	StrCpy(yylval.stri, yytext, yyleng);	return T_word;		}

<LINE>.*	{	StrCpy(yylval.stri, yytext, yyleng);	return T_line;		}

<VALUE>{VALU}	{	StrCpy(yylval.stri, yytext, yyleng);	return T_word;		}

<VALUE>\"	{	yystring[0] = '\0';  BEGIN(DQUOTE);  		}
<VALUE>\'	{	yystring[0] = '\0';  BEGIN(SQUOTE);		}

<DQUOTE>{DVAL}	{ 	strncat(yystring, yytext, yyleng);              }
<SQUOTE>{SVAL}	{ 	strncat(yystring, yytext, yyleng);              }
<DQUOTE>\\.     {	strncat(yystring, yytext, yyleng);              }
<SQUOTE>\\.     {	strncat(yystring, yytext, yyleng);              }
<DQUOTE>\"      {	BEGIN(VALUE);
                        StrCpy(yylval.stri, yystring, strlen(yystring) + 1); return T_word; }
<SQUOTE>\'      {	BEGIN(VALUE);
                        StrCpy(yylval.stri, yystring, strlen(yystring) + 1); return T_word; }

^#.*$		{
			char	*value;
			int	mode = 0;

		  yylval.param = ParamCreate("#"
				, CommentType
				, &mode, StrCpy(value, yytext, yyleng)
				, NULL);

		  return T_comment;
		}

^[ \t]+$       	{
			char	*value;
			int	mode = 0;
		  yylval.param = ParamCreate(""
				, CommentType
				, &mode, StrCpy(value, yytext, yyleng)
				, NULL);

		  return T_comment;
		}
[ \t]+		{		}
,		{ 	BEGIN(yyfields[++yyfield]);		return ','; }
\n		{	
			yylineno++;
			BEGIN(yyfields[yyfield = 0]);		return T_nl;
		}




%%

/* Lexical tie called by grammar
**/
void yybegin(state)
    int state;
{
	BEGIN(state);

}


yyreparse()
{
	BEGIN(yyfields[yyfield = 0]);
}
