/* parament.c
**
** ParamEntry();
**/

#include <string.h>

#include "pfile.h"


int ParamAccess(pfile, name)
			ParamFile	 pfile;
			char		*name;
{
	return ParamLookup(pfile->psets, name) != NULL;
}


int ParamInfo(pfile, name, mode, type, value, min, max, prompt)
			ParamFile	pfile;
			char	*name, *mode, *type, *value, *min, *max, *prompt;
{
	if ( !pfile ) return 0;

	return ParamEntry(ParamLookup(pfile->psets, name)
		, NULL, mode, type, value, min, max, prompt);
}

char *ParamResolve(pfile, name, str, max)
			ParamFile       pfile;
			char		*name;
			char		*str;
			int		 max;
{
		int mode=pfile->mode;
		void *value;
		if( value = ParamGetX(pfile, name, StringType, &mode) )
		  strncpy(str, value, max);
		else
		  *str = '\0';
		return str;
}	

int ParamEntry(p, name, mode, type, value, min, max, prompt)
			Parameter	*p;
			char	*name, *mode, *type, *value, *min, *max, *prompt;
{
	if ( !p ) return 0;

	if ( name )	strcpy(name, p->pname);
	if ( mode )	Convert(&p->pmode, ModeType, mode, StringType);
	if ( type )	Type2String(p->ptype, type);
	if ( value )
		     if ( p->pvalue.indir )
			strcpy(value, p->pvalue.indir);
		else
			VConvert(&p->pvalue, value, StringType);
		
	if ( min )
		if ( p->pmin.indir )
			strcpy(min, p->pmin.indir);
		else
			VConvert(&p->pmin, min, StringType);
	if ( max )
		if ( p->pmax.indir )
			strcpy(max, p->pmax.indir);
		else
			VConvert(&p->pmax, max,   StringType);

	if ( prompt )	strcpy(prompt, p->pprompt ? p->pprompt : "");

	return 1;
}
