/* pline.c
**/

#include <unistd.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"

main(argc, argv)
     int	 argc;
     char	*argv[];
{
  int dopkg;
  int pname;
  int i;
  char *name;
  char value[SZ_PFLINE];
  paramfile pfile;
  pmatchlist pml;

  if ( argc == 1 ) {
    fprintf(stderr, "pline: no paramfiles to list\n");
    exit(1);
  }

  /* look for flag to print out pkg name */
  if( !strcmp(argv[1], "-pkg") ){
    dopkg = 1;
    pname = 2;
  }
  else{
    dopkg = 0;
    pname = 1;
  }

  if ( !(pfile = paramopen(NULL, &argv[pname], argc - pname, "rH")) ) {
    fprintf(stderr, "pdump: can't open parameter file: %s\n", pfilelast());
    exit(1);
  }

  /* open the match list for all params */
  pml = pmatchopen(pfile, NULL);
  /* display each param value in name='value' format */
  for(i=0; (name=pmatchnext(pml)) != NULL; i++ ){
    if( pgetstr(pfile, name, value, SZ_PFLINE) ){
      if( dopkg ){
	printf("%s.%s='%s'\n", argv[pname], name, value);
      }
      else{
	printf("%s='%s'\n", name, value);
      }
    }
  }
  /* close the match list */
  pmatchclose(pml);
  printf("# EOF\n");
  paramclose(pfile);
  exit(0);
}
