/* pget.c
**/
#include <unistd.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"


main(argc, argv)
			int	 argc;
			char	*argv[];
{
		ParamFile		pfile;
		int			i;

	if ( argc <= 2 ) {
		fprintf(stderr, "usage: pget pfile param1 [param2 ...]\n");
		exit(1);
	}

	if ( !(pfile = (ParamFile) paramopen(argv[1], NULL, 0, "r")) ) {
	    fprintf(stderr, "pset: can't open parameter file : %s\n", argv[1]);
		exit(1);
	}

	paramunlock(pfile);

	for ( i = 2; i < argc; i++ ) {
			void	*value;
			int	 mode = HMODE;

		if ( value = ParamGetX(pfile, argv[i], StringType, &mode) )
			fprintf(stdout, "%s\n", value);
		else 
			paramerr(1, "pget", argv[i]);
	}


	paramclose(pfile);
	return 0;

}

