/* pline.c
**/

#include <unistd.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"

main(argc, argv)
     int	 argc;
     char	*argv[];
{
  int dopkg;
  int docl;
  int pname;
  int i;
  char *name;
  char value[SZ_PFLINE];
  paramfile pfile;
  pmatchlist pml;
  char mode[20], partype[20], parvalue[128];
  char parmin[20], parmax[20], prompt[128];

  if ( argc == 1 ){
    fprintf(stderr, "pline: no paramfiles to list\n");
    exit(1);
  }

  /* look for flag to print out pkg name */
  dopkg = 0;
  docl = 0;
  pname = 1;
  for(i=1; i<argc && argv[i][0] == '-'; i++){
    if( !strcmp(argv[i], "-pkg") ){
      dopkg = 1;
      pname++;
    }
    else if( !strcmp(argv[i], "-cl") ){
      docl = 1;
      pname++;
    }
  }

  if ( !(pfile = paramopen(NULL, &argv[pname], argc - pname, "rH")) ) {
    fprintf(stderr, "pline: can't open parameter file: %s\n", pfilelast());
    exit(1);
  }

  /* open the match list for all params */
  pml = pmatchopen(pfile, NULL);
  /* display each param value in name='value' format */
  for(i=0; (name=pmatchnext(pml)) != NULL; i++ ){
    /* IRAF CL style output */
    if( docl ){
      if(ParamInfo(pfile, name, mode,
		   partype, parvalue, parmin, parmax, prompt)){
        if (i != 0)
	  printf(",");
	if( dopkg )
	  printf("%s.", argv[pname]);
	/* print string values with quotes */
        if (partype[0] == 's' || partype[0] == 'f')
	  printf("%s=\"%s\"", name, parvalue);
        else{
	  /* 0 values come back as null strings -- watch out! */
	  if (strlen(parvalue) == 0)
	    printf("%s=0",name,parvalue);
	  else
	    printf("%s=%s",name,parvalue);
	}
      }
    }
    /* Unix style output */
    else{
      if( pgetstr(pfile, name, value, SZ_PFLINE) ){
	if( i != 0 )
	  printf(" ");
	if( dopkg )
	  printf("%s.", argv[pname]);
	printf("%s='%s'", name, value);
      }
    }
  }
  /* close the match list */
  pmatchclose(pml);
  printf("\n");
  paramclose(pfile);
  exit(0);
}
