/* pquery.c
**/

#include <unistd.h>
#include <string.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"

main(argc, argv)
			int	 argc;
			char	*argv[];
{
		paramfile	  pfile;
		int		  pmode;
		char		value[SZ_PFLINE];

		char		*progname;
		char		*mode;

	if ( (progname = strrchr(argv[0], '/')) )
		progname++;
	else	progname = argv[0];

	if ( !strcmp(progname, "pquery") )	mode = "rwl";
	else					mode = "r";

	if ( argc <= 2 ) {
	   fprintf(stderr, "usage: pquery pfile param [param1=value ...]\n");
		exit(1);
	}

	if ( !(pfile = paramopen(argv[1], &argv[2], argc - 2, mode)) ) {
	  fprintf(stderr, "pquery: can't open parameter file : %s\n", argv[1]);
		exit(1);
	}

	if ( argv[2][0] == '-' ) {
			char	tok[SZ_PFLINE];

		while ( 1 ) {
			if ( SkipWhite(stdin)         == -1 ) break;
			if ( ReadTok(stdin, tok, SZ_PFLINE) == -1 ) break;

			if ( pgetstr(pfile, tok, value, SZ_PFLINE) )
				fprintf(stdout, "%s	", value);
			else
				paramerr(1, "pquery", argv[2]);
		}
		fprintf(stdout, "\n");
	} else
		if ( pgetstr(pfile, argv[2], value, SZ_PFLINE) )
			fprintf(stdout, "%s\n", value);
		else
			paramerr(1, "pquery", argv[2]);

	paramclose(pfile);
        return 0;		
}


SkipWhite(file)
			FILE	*file;
{
		char ch = getc(stdin);

	while ( ch == ' ' 
	   ||   ch == '\n'
	   ||   ch == '\t'
	   ||   ch == ':'
	   ||   ch == '\0'
	   ||   ch == EOF
	) {
		if ( ch == '\0' ) return -1;
		if ( ch == EOF   ) return -1;
		ch = getc(stdin);
	}

	ungetc(ch, stdin);

	return 1;
}


ReadTok(file, token, max)
			FILE	*file;
			char	*token;
			int	max;
{
		int	i;

	for ( i = 0; i < max; i++ ) {

		token[i] = getc(file);

		if ( !i && token[i] == '\0' ) return -1;

		if (  token[i] == ' ' 
		   || token[i] == '\n'
		   || token[i] == '\t'
		   || token[i] == ':'
		   || token[i] == '\0'  ) break;
	}

	token[i] = '\0';

	return 1;
}
