/* pset.c
**/

#include <unistd.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"


main(argc, argv)
			int	 argc;
			char	*argv[];
{
		ParamFile	  pfile;
		Parameter 	**params;

	if ( argc <= 1 ) {
	    fprintf(stdout, "usage: pset pfile [param1[=value] param2 ...]\n");
		exit(1);
	}

	if ( !(pfile = paramopen(argv[1], NULL, 0, "rwl")) ) {
	   fprintf(stderr, "pset: can't open parameter file : %s\n", argv[1]);
		exit(1);
	}

	if ( argc == 2 ) {
		for ( params = pfile->psets->param; *params; params++ ) {
		    if ( TypeIndex((*params)->ptype) == CommentType ) continue;

		    ParamSetX(pfile, (*params)->pname, StringType, NULL);
		}
	} else {
			ParamList *alist;

		if ( !(alist = ParamFileArgs(pfile->psets, &argv[2], argc - 2)) )
			exit(1);

		for ( params = alist->param; *params; params++ )
		    pputstr(pfile, (*params)->pname, (*params)->pvalue.value);
	}

	paramclose(pfile);
	return 0;
}



