/* ptemplat.c
**/
#include <stdlib.h>
#include <string.h>

#include "list.h"
#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"


pmatchlist pmatchopen(pfile, template)
			ParamFile	 pfile;
			char		*template;
{
		ParamMatchList	*mlist;
		ParamList	*plist;
		void		*list = NULL;
		int		leng = 0;
		int		i;

	if ( !pfile ) return NULL;
	if ( !pfile->psets ) return NULL;

	if ( template && !strcmp(template, "*") ) template = NULL;
	plist = pfile->psets;

	for ( i = plist->nparam; i--; )
		if ( plist->param[i]->ptype != CommentType
		    && (  !template 
			|| tmatch(plist->param[i]->pname, template) ) ) {
				ParamMatchEntry *e;

			e = (ParamMatchEntry *)malloc(sizeof(ParamMatchEntry));
			e->next = NULL;
			e->name = NewString(plist->param[i]->pname);
			list = (ParamMatchEntry *) ListPush(list, e);
			leng++;
		}

	mlist = (ParamMatchList *)malloc(sizeof(ParamMatchList));

	mlist->list = list;
	mlist->next = list;
	mlist->leng = leng;

	return mlist;
}
	

char *pmatchnext(mlist)
			ParamMatchList	*mlist;
{
		char *name;

	if ( !mlist ) return NULL;

	name 		= mlist->next ? mlist->next->name : NULL;
	mlist->next	= mlist->next ? mlist->next->next : NULL;

	return name;
}


void pmatchrewind(mlist)
			ParamMatchList	*mlist;
{
	mlist->next = mlist->list;
}

 
int pmatchlength(mlist)
			ParamMatchList *mlist;
{
	return mlist->leng;
}


void pmatchclose(mlist)
			ParamMatchList *mlist;
{
		ParamMatchEntry	*e;
		ParamMatchEntry	*next;

	if ( !mlist ) return;

	if ( !mlist->list ) {
		free(mlist);
		mlist = NULL;
		return;
	}
	next = mlist->list;
	free(mlist);
        mlist = NULL;
		
	while ( e = next ) {
		next = (ParamMatchEntry *) ListPop(e);
		free(e->name);
		free(e);
		e = NULL;
	};
}
