/* punlearn.c

   Implimentaton:

   Add a ";" delimiter to split PFILES into FRONT and BACK sections

             <---FRONT------------>  <---BACK--------------->
     PFILES="uparm pfiles job1 job2; paramdefault irafdefault"

   Add a flag to paramopen to control the search for a pfile.

   A call with the reference flag set forces an open of paramfile from
   the BACK portion of PFILES.

   Force write to always happen to a file in the FRONT part of PFILES


   With the above rules a normal paramopen looks through FRONT and BACK
   to find a paramfile.  A paramopen with "R" mode set looks through 
   BACK only to find the "reference" copy of the file.  Both modes
   write out only to a copy of the paramfile in the FRONT part of
   PFILES.
*/

#include <unistd.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"

main(argc, argv)
     int	 argc;
     char	*argv[];
{
  paramfile pfile;

  if ( argc == 1 ) {
    fprintf(stderr, "plist: no paramfiles to unlearn\n");
    exit(1);
  }

  for ( argv++; argc-- >= 2; argv++ ) {
    if ( !(pfile = paramopen(*argv, NULL, 0, "rwR")) ) {
      fprintf(stderr, "punlearn: can't open parameter file: %s\n", *argv);
      exit(1);
    }
    /* fclose (and write)
     */
    paramclose(pfile);		/* writes always happen to a
				 * file in FRONT */
  }

  return 0;
}



