

%x WIDTH BODY

%{
/* rdbpar.l
**/

#include <string.h>
#include <stdlib.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"

extern int *String2Mode();

/* default rdbwrap function - always treat EOF as an EOF */
#define rdbwrap() 1

#define StrCpy(res, str, len)	( strncpy((res=malloc(len + 1)), str, len),\
					res[len] = '\0', res)

/* This array and the field variable to cycle through the  context dependence
** of the current field that is expected.
**/
static int	fields[7];
static int	widths[7];
static int	field = 0;
static Parameter *p;
static ParamList *result;

#define YY_USER_INIT	{ BEGIN(fields[field = 0]);		}
/**
#define YY_USER_ACTION  { printf("field = %d, state = %d\n", field, yy_start); }
**/

#define P	printf

#undef  YY_INPUT
#define YY_INPUT(buffer, result, max)					\
	{								\
		result = fread(buffer, 1, max, (FILE *) yyin);		\
	}

#define NAME	0
#define TYPE	1
#define MODE	2
#define VALUE	3
#define MIN	4
#define MAX	5
#define PROMPT	6

%}


%%

name		{	fields[field] = NAME;		}
mode		{	fields[field] = MODE;		}
value		{	fields[field] = VALUE;		}
type		{	fields[field] = TYPE;		}
min		{	fields[field] = MIN;		}
max		{	fields[field] = MAX;		}
prompt		{	fields[field] = PROMPT;		}
\n		{	field = 0;
			BEGIN(WIDTH);
		}

<WIDTH>-+	{	widths[field] = strlen(yytext);	}
<WIDTH>\n	{	field = 0;
			BEGIN(BODY);
		}

<BODY>[^\n\t]+	{	
  switch ( fields[field] ) {
    char *s;
    int  mode;

  case NAME:
    p = ParamName(p, StrCpy(s, yytext, yyleng)); break;

  case TYPE:
    if ( p )
      if ( !ParamType(p, String2Type(yytext))) {
	paramerr(0, "rdb parser", p->pname);
	free(p);
      }
    break;

  case MODE:
    if ( p ) 
      if ( !ParamMode(p, String2Mode(yytext, &mode))) {
	paramerr(0, "rdb parser", p->pname);
	free(p);
      }
    break;

  case VALUE:
    if ( p ) p = ParamValue(p, StringType, StrCpy(s, yytext, yyleng)); break;
  case MIN:
    if ( p ) p = ParamMin(p, StringType, StrCpy(s, yytext, yyleng)); break;
  case MAX:
    if ( p ) p = ParamMax(p, StringType, StrCpy(s, yytext, yyleng)); break;
  case PROMPT:
    if ( p ) p = ParamPrompt(p, StrCpy(s, yytext, yyleng)); break;
			}
		}
<BODY>\n	{	if ( p && !p->pvalue.value )
				VNewValue(&p->pvalue, "", StringType);

			if ( p )
			  result = PListAdd(result, p);

			field = 0;
			p = NULL;
		}
<INITIAL,WIDTH,BODY>\t {	field++;		}

<<EOF>>		{ return 1;	};
.		{ return 0; 	}
%%


ParamList *RDBParFile(f)
			FILE	*f;
{
		static parser = 0;

	if ( parser ) {
		yyrestart((FILE *) f);
		BEGIN(0);
	} else {
		yyin = (void *) f;
		parser = 1;
	}

	result = NULL;
	if ( !yylex() && result ){
            PFree(result);
	    result = (ParamList *)NULL;
         }

	return result;
}
