/* rdb.c
**
	Routines to manipulate rdb parameter files.
**/

#include <string.h>

#include "pfile.h"
#include "ptemplat.h"
#include "parameter.h"
#include "putil.h"

static ParamList	*RDBParRead();
       void		 RDBParWrit();
static void		 RDBParW();

extern ParamList	*RDBParFile();
extern ParamList	*IRAFParArgs();

/*
	The mode argument:

		"l"	lock file for exclusive access.
*/

ParamList *RDBParOpen(filename, mode)
     char	*filename;
     char	*mode;
{
  FILE		*f;
  ParamList	*plist;
  char		*fmode = strpbrk(mode, "w" ) == NULL ? 
    "r" : "r+";

  if ( !filename ) return NULL;

  if ( !(f = fopen(Find(filename, fmode, ".rdb", PARAMPATH), fmode)) )
    return NULL;

	if ( strpbrk(mode, "l" ) ) Lock(f);

	if ( !(plist = RDBParFile(f)) )
		return (ParamList *) ParamFileCant;

	plist->file = f;
  	plist->filename = NewString(filename);
  	plist->mode = NewString(mode);
	plist->read = RDBParRead;
	plist->writ = RDBParWrit;
	plist->clos = NULL;

	return plist;
}


static ParamList *RDBParRead(file, mode)
			FILE	*file;
			char	*mode;
{
	if ( strpbrk(mode, "l") ) Lock(file);
	fseek(file, 0, 0);


	return RDBParFile(file);
}


void RDBParWrit(file, plist, mode)
			FILE		*file;
			ParamList	*plist;
			char		*mode;
{
		int	i;

	fseek(file, 0, 0);

	fprintf(file, "name\ttype\tmode\tvalue\tmin\tmax\tprompt\n");
	fprintf(file, "----\t----\t----\t-----\t---\t---\t------\n");

	for ( i = 0; i < plist->nparam; i++ )
		RDBParW(plist->param[i], file);

	fflush(file);
	ftruncate(fileno(file), ftell(file));
}

static void RDBParW(p, f)
			Parameter	*p;
			FILE		*f;
{
		char	namestr[SZ_PFLINE];
		char	typestr[SZ_PFLINE];
		char	modestr[SZ_PFLINE];
		char	valustr[SZ_PFLINE];
		char	minnstr[SZ_PFLINE];
		char	maxxstr[SZ_PFLINE];
		char	promstr[SZ_PFLINE];

	ParamEntry(p, namestr, modestr, typestr
			, valustr,minnstr, maxxstr, promstr);

	fprintf(f, "%s\t%s\t%s\t%s\t%s\t%s\t%s\n"
		, namestr
		, typestr
		, modestr
		, valustr
		, minnstr
		, maxxstr
		, promstr);
}
