/* real.c
**
**/


#include <stdlib.h>
#include <string.h>

#include "pfile.h"
#include "range.h"

static void *Int2Real(), *String2Real(), *Bool2Real();

static int   Size(), Comp();

static Converter Converters[] = {
	{IntegerType,	RealType,  Int2Real},
	{StringType,	RealType,  String2Real},
	{BooleanType,	RealType,  Bool2Real},
	{NULL,		NULL,	   NULL}
};


vtype realRec = {
	"r",
	Converters,

	Size,
	VXAcce,
	Comp
};


static void *String2Real(value, copy)
			char	*value;
			real	*copy;
{
		char	*scanto;
		double strtod();
		

	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	if ( !strcmp(value, "INDEF") || !strcmp(value, "INDEFD") ) {
		*copy = INDEFD;
		return copy;
	}

	*copy = strtod(value, &scanto);

	if ( *scanto ) {
		parerr = PARCANTCONVERT;
		return NULL;
 	}

	return copy;
}

static void *Int2Real(value, copy)
			int	*value;
			real	*copy;
{
	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	*copy = *value;
	return copy;
}


static void *Bool2Real(value, copy)
			bool	*value;
			real	*copy;
{
	if ( !value ) return NULL;
	if ( !copy  ) return NULL;

	*copy = *value == 1;
	return copy;
}


static int Size(value)
			void *value;
{
	return sizeof(real);
}

static int Comp(pvalue1, pvalue2, type)
			void	*pvalue1;
			void	*pvalue2;
			int	type;
{
  real *value1 = (real *) pvalue1;
  real *value2 = (real *) pvalue2;

	if ( *value1 == INDEFD || *value2 == INDEFD ) return 1;

	switch ( type ) {
	 case PRange_EQ: return *value1 == *value2;
	 case PRange_NE: return *value1 != *value2;
	 case PRange_GT: return *value1 >  *value2;
	 case PRange_GE: return *value1 >= *value2;
	 case PRange_LT: return *value1 <  *value2;
	 case PRange_LE: return *value1 <= *value2;
	 default: return 0;
	}
}
