C uclx - an iraf F77VOS emulation
C

C uclinit()
C
C This is an additional routine to allow fortran to initialize
C the default parameter file without a C main.  Its function 
C is the same as the C routine clinit.
C
      subroutine uclinit()
      implicit none

      include 'pfcommon.f'

      call paramopen('$', '$rw', PFFile)
      end

C uclxfile()
C
C This is an additional routine to allow the PFFile common
C to be set from C without worrying about linking.
C
      subroutine uclxfile(pfile)
      implicit none

      integer        pfile

      include 'pfcommon.f'

      PFFile = pfile
      end

C uclxdone()
C
C This is an additional routine that closes the default parameter file
C
      subroutine uclxdone()
      implicit none

      include 'pfcommon.f'

      call paramclose(PFFile)
      end


C PGETS
C

C pget a boolean
C
      subroutine uclgsb(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pgetb(PFFile, pname, value, stat)
      end


C pget a short
C
      subroutine uclgss(pname, value, stat)
      implicit none

      character	*(*) pname
      integer   *2   value
      integer	     stat

      include 'pfcommon.f'

      call pgets(PFFile, pname, value, stat)
      end


C pget an integer
C
      subroutine uclgsi(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pgeti(PFFile, pname, value, stat)
      end


C pget a long
C
      subroutine uclgsl(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pgetl(PFFile, pname, value, stat)
      end


C pget a real
C
      subroutine uclgsr(pname, value, stat)
      implicit none

      character	*(*) pname
      real      *4   value
      integer	     stat

      include 'pfcommon.f'

      call pgetr(PFFile, pname, value, stat)
      end


C pget a double
C
      subroutine uclgsd(pname, value, stat)
      implicit none

      character	*(*) pname
      real      *8   value
      integer	     stat

      include 'pfcommon.f'

      call pgetd(PFFile, pname, value, stat)
      end


C pget a string
C
      subroutine uclgst(pname, value, stat)
      implicit none

      character	*(*) pname
      character *(*) value
      integer	     stat

      include 'pfcommon.f'

      call pgetstr(PFFile, pname, value, stat)
      end


C PPUTS
C

C pput a boolean
C
      subroutine uclpsb(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pputb(PFFile, pname, value, stat)
      end


C pput a short
C
      subroutine uclpss(pname, value, stat)
      implicit none

      character	*(*) pname
      integer   *2   value
      integer	     stat

      include 'pfcommon.f'

      call pputs(PFFile, pname, value, stat)
      end


C pput an integer
C
      subroutine uclpsi(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pputi(PFFile, pname, value, stat)
      end


C pput a long
C
      subroutine uclpsl(pname, value, stat)
      implicit none

      character	*(*) pname
      integer        value
      integer	     stat

      include 'pfcommon.f'

      call pputl(PFFile, pname, value, stat)
      end


C pput a real
C
      subroutine uclpsr(pname, value, stat)
      implicit none

      character	*(*) pname
      real      *4   value
      integer	     stat

      include 'pfcommon.f'

      call pputr(PFFile, pname, value, stat)
      end


C pput a double
C
      subroutine uclpsd(pname, value, stat)
      implicit none

      character	*(*) pname
      real      *8   value
      integer	     stat

      include 'pfcommon.f'

      call pputd(PFFile, pname, value, stat)
      end


C pput a string
C
      subroutine uclpst(pname, value, stat)
      implicit none

      character	*(*) pname
      character *(*) value
      integer	     stat

      include 'pfcommon.f'

      call pputstr(PFFile, pname, value, stat)
      end
