/*
 *
 * PTEST -- test F77 parameter interface for HEASARC programs
 * This main program could serve as a template for HEASARC programs
 *
 */
#include <stdio.h>

/*
  We must parameterize the name of the F77 routine to call
  in order to deal with the different C->F77 bindings that
  are used by different systems.  In general, the unix F77
  compiler adds "_" to its entries to distinguish C from Fortran.
  VMS does not do this. A separate entry should be made for each
  different scheme
*/
#ifdef unix
#define FTEST ftest_
#endif
#ifdef vms
#define FTEST ftest
#endif

/* this is the default parameter file, if one is not specified on the
   command line */
#define DEFAULT_PFILE "heasarc.par"

/* main is just a short routine that opens the default param file and
   calls the F77 routine */
main(argc, argv)
     int argc;
     char **argv;
{
  /* open the default parameter file */
  OpenDefaultPF(argc, argv, DEFAULT_PFILE);

  /* call the F77 routine - this is where the beef is! */
  FTEST();

  /* close the default parameter file */
  CloseDefaultPF();
}
