/* vmsfbind.c
**/

#ifdef vms

#include descrip.h

typedef struct dsc$descriptor descriptor;

#define DataLength(x)	x->dsc$w_length
#define DataAddrss(x)	x->dsc$a_pointer
#else

typedef struct desc {
	int	 dscw_length;
	char	*dsca_pointer;
} descriptor;

#define DataLength(x)	x->dscw_length
#define DataAddrss(x)	x->dsca_pointer
#endif

#include "pfile.h"

/* For Fortran a pointer is an int
**/
#define paramfile	int
extern  paramfile	c_paramopen();

extern char	**GetF77argv();
extern char	 *strf2c();
extern void	  strc2f();
extern char	  CString1[];
extern char	  CString2[];

#define F2CStr	strf2c
#define C2FStr	strc2f

#define F2CStr1(length, string)	F2CStr(length, string, CString1)
#define F2CStr2(length, string)	F2CStr(length, string, CString2)

paramfile c_paramopen();

void paramopen(filename_d, mode_d, pf)
			descriptor	*filename_d;
			descriptor	*mode_d;
			paramfile 	*pf;
{
		char		*filename 	= DataAddrss(filename_d);
		int	 	 nfilename	= DataLength(filename_d);
		char		*mode		= DataAddrss(mode_d);
		int	 	 nmode		= DataLength(mode_d);

		int	  argc;
		char	**argv;
	
		char	 *cmode;
		int	i;

	argv = GetF77argv(&argc);

	if ( !strpbrk(cmode = F2CStr1(nmode, mode), "$") )
		argc = 1;

	*pf = c_paramopen( (!filename
			 ||  filename && *filename == '$' && nfilename == 1 )
			? NULL : F2CStr2(nfilename, filename)
			, argv, argc, cmode);
}

void paramlist(pfile)
			paramfile *pfile;
{
	c_paramlist(*pfile);
}


void paramclose(pfile)
			paramfile *pfile;
{
	c_paramclose(*pfile);
}

paramfind(name_d, path_d)
			descriptor	*name_d;
			descriptor	*path_d;
{
		char	*name	= DataAddrss(name_d);
		int	 nname	= DataLength(name_d);
		char	*path	= DataAddrss(path_d);
		int	 npath	= DataLength(path_d);

	C2FStr(c_paramfind(F2CStr1(nname, name)), path, npath);
}

paramerr(level, message_d, name_d)
			int		*level;
			descriptor	*message_d;
			descriptor	*name_d;
{
		char	*message	= DataAddrss(message_d);
		int	 nmessage	= DataLength(message_d);
		char	*name		= DataAddrss(name_d);
		int	 nname		= DataLength(name_d);

	c_paramerr(*level, F2CStr1(nmessage, message), F2CStr2(nname, name));
}

paramerrstr(errstr_d)
			descriptor	*errstr_d;
{
		char	*errstr	= DataAddrss(errstr_d);
		int	 nerrstr= DataLength(errstr_d);

	C2FStr(c_paramerrstr(), errstr, nerrstr);
}

#define ParamGet(Return, Routine, Type, type, chekindef, retindef)	\
									\
void Routine(pfile, name_d, value, status)				\
			ParamFile	*pfile;				\
			descriptor	*name_d;			\
			Return		*value;				\
			int		*status;			\
{									\
		char	*name	= DataAddrss(name_d);			\
		int	 nname	= DataLength(name_d);			\
		type	*v;						\
									\
	*status = 0;							\
									\
	if ( v = ParamGetX(*pfile, F2CStr1(nname, name)			\
			 , Type, &(*pfile)->mode))			\
	    if (*v == chekindef ) {					\
		*status = 3;						\
		*value  = retindef;					\
	    } else							\
	    	*value  = *v;						\
	else								\
		*status = 1;						\
									\
}

ParamGet(int,	pgetb, BooleanType, int, INDEFI, INDEFI)
ParamGet(short, pgets, IntegerType, int, INDEFI, INDEFS)
ParamGet(int,	pgeti, IntegerType, int, INDEFI, INDEFI)
ParamGet(int,	pgetl, IntegerType, int, INDEFI, INDEFI)
ParamGet(float, pgetr, RealType,    real,INDEFD, INDEFR)
ParamGet(float, pgetf, RealType,    real,INDEFD, INDEFR)
ParamGet(double,pgetd, RealType,    real,INDEFD, INDEFD)

void pgetstr(pfile, name_d, string_d, status)
			ParamFile	*pfile;
			descriptor	*name_d;
			descriptor	*string_d;
			int		*status;
{
		char	*string		= DataAddrss(string_d);
		int	 nstring	= DataLength(string_d);
		char	*name		= DataAddrss(name_d);
		int	 nname		= DataLength(name_d);

		void	*v;

	*status = 0;

	if ( v = ParamGetX(*pfile, F2CStr1(nname, name), StringType, &(*pfile)->mode))
		C2FStr(v, string, nstring);
	else
		*status = 1;
}


#define ParamPut(Take, Routine, Type, type, chekindef, putindef)	\
									\
void Routine(pfile, name_d, value, status, length)			\
			ParamFile	*pfile;				\
			descriptor	*name_d;			\
			Take		*value;				\
			int		*status;			\
{									\
		char	 *name	= DataAddrss(name_d);			\
		int	  nname = DataLength(name_d);			\
									\
		type xvalue = *value;					\
									\
	*status = 0;							\
									\
	if ( *value == chekindef ) xvalue = putindef;			\
	else			   xvalue = xvalue;			\
									\
	if ( !ParamSetX(*pfile, F2CStr1(nname, name), Type, &xvalue) )	\
		*status = 1;						\
}


ParamPut(int,	pputb, BooleanType, int, INDEFI, INDEFI)
ParamPut(short,	pputs, IntegerType, int, INDEFS, INDEFI)
ParamPut(int,	pputi, IntegerType, int, INDEFI, INDEFI)
ParamPut(int,	pputl, IntegerType, int, INDEFI, INDEFI)
ParamPut(float,	pputr, RealType,    real,INDEFR, INDEFD)
ParamPut(float,	pputf, RealType,    real,INDEFR, INDEFD)
ParamPut(double,pputd, RealType,    real,INDEFD, INDEFD)

void pputstr(pfile, name_d, string_d, status)
			ParamFile	*pfile;
			descriptor	*name_d;
			descriptor	*string_d;
			int		*status;
{
		char	*string		= DataAddrss(string_d);
		int	 nstring	= DataLength(string_d);
		char	*name		= DataAddrss(name_d);
		int	 nname		= DataLength(name_d);

	*status = 0;

	if ( !ParamSetX(*pfile, F2CStr1(nname, name), StringType
			, F2CStr2(nstring, string)) )
		*status = 1;
}
