#include <stdlib.h>
#define DMSOURCE
#include "ascdm.h"
/*
 *--------------------------------------------------------------------------------
 * ASCDM compatibility routines
 *--------------------------------------------------------------------------------
 */

/*
 *
 * dmDatasetGetBlockType
 *
 * Get type of block given block number in dataset.
 */
dmBlockType dmDatasetGetBlockType( dmDataset* ds, int block_no )
{
 t_word typename;
 dmDatasetGetBlockTypeName( ds, block_no, typename );
 return( dmASCBlockType( typename ) );
}

/*
 * dmBlockGetType
 *
 * Get block type (ASCDM type)
 */
dmBlockType dmBlockGetType( dmBlock* block )
{
 t_word typename;
 dmBlockGetTypeName( block, typename );
 return( dmASCBlockType( typename ) );
}
/*
 * dmBlockGetTypeStr
 *
 * ASC memory allocation version
 */
char* dmBlockGetTypeStr( dmBlock* block )
{
 char* ptr;
 if ( block ) {
  ptr = (char*)malloc( WSIZE );
  dmBlockGetTypeName( block, ptr );
 } else {
  ptr = NULL;
 }
 return( ptr );
}

/*
 * dmGetName
 *
 * ASC version
 */

char* dmGetName( dmDescriptor* dd )
{
 char* name;
 name =(char*) malloc( WSIZE );
 dmGetNameC( dd, name );
 return( name );
}


char* dmGetUnit( dmDescriptor* dd )
{
 char* unit;
 unit = (char*)malloc(WSIZE);
 dmGetUnitC( dd, unit );
 return( unit );
}


char* dmGetDesc( dmDescriptor* dd )
{
 char* desc;
 desc = (char*)malloc(CSIZE);
 dmGetDescC( dd, desc );
 return( desc );
}

dmDataType dmGetDataType( dmDescriptor* dd )
{
 t_word typename;
 dmGetDataTypeNameC( dd, typename );
 return( dmASCDataType( typename ) );
}

char* dmGetDataTypeName( dmDescriptor* dd )
{
 char* name;
 name = (char*)malloc(WSIZE);
 dmGetDataTypeNameC( dd, name );
 return( name );
}
