#include <stdlib.h>
#define DMSOURCE
#include "ascdm.h"

/*
 * dmDatasetOpen
 *
 * Open a dataset, return a pointer
 */
dmDataset* dmDatasetOpen( char* filename )
{
 dmDataset* ds = NULL;
 dmKernelDataset* fptr;
 dmKernel* kernel;
 int i;
 card buf;
 if ( cs_is_blank( filename ) ) return( NULL );

 for ( i = 0; i < dmGetNoKernels(); i++ ) {
  kernel = dmGetKernelNo(i+1);
  dmsg( 1, "Attempt kernel open" );
  fptr = kernel->dmkDatasetOpen( filename );
  if ( fptr ) {
   sprintf( buf, "Allocate dataset %p", fptr ); dmsg( 1, buf );
   ds = dmiDatasetAlloc( filename, kernel, fptr, "R"  );
   if ( ds ) { 
    dmsg( 1, "Allocate dataset OK" );
   } else { 
    dmiErrorSet( ERR_MALLOC_FAIL );
   }
   return( ds );
  }
 }
 dmsg1( 1, "Failed to open ", filename );
 dmiErrorSet( ERR_OPEN_FAIL );
 return( NULL );
}


/*
 * dmDatasetClose
 *
 * Close a dataset
 */
int dmDatasetClose( dmDataset* ds )
{
 int status = 0;
 int no;
 dmsg( 1, "Close blocks" );
 if ( ds ) {
  for ( no = 0; no < ds->nblocks; no++ ) {
   dmBlockClose( ds->block[no] );
  }
  status = ds->kernel->dmkDatasetClose( ds->fptr );
  dmsg( 1,"Free dataset" );
  dmiDatasetFree( ds );
  dmsg( 1,"Exit close" );
 }
 return( status );
}

