#include <stdlib.h>
#define DMSOURCE
#include "ascdm.h"

/*
 * dmASCBlockType
 *
 * Convert block type to enum
 */
dmBlockType dmASCBlockType( char* typename )
{
 dmBlockType type;
 if ( cs_eq( typename, "TABLE" ) ) {
  type = dmTABLE;
 } else if ( cs_eq( typename, "IMAGE" ) ) {
  type = dmIMAGE;
 } else {
  type = dmUNKNOWNBLOCK;
 }
 return( type );
}

void dmASCBlockTypeName( dmBlockType type, char* typename )
{
 switch( type ) {
  case dmTABLE:
   cs_copy( "TABLE", typename ); break;
  case dmIMAGE:
   cs_copy( "IMAGE", typename ); break;
  default:
   cs_copy( " ", typename );
 }
}


/*
 * dmASCDataType
 *
 * Convert block type to enum
 */
dmDataType dmASCDataType( char* typename )
{
 dmDataType type;
 int itype;
 char* names[] = { "s", "i", "r", "d", "c", "br", "q", "ub", "us", "ul", " " };
 dmDataType types[] = { dmSHORT, dmLONG, dmFLOAT, dmDOUBLE, dmSTRING, dmBLOCKREF, dmLOGICAL, dmBYTE, dmUSHORT, dmULONG, dmVOID };

 if ( cs_eq( typename, "l" ) ) {
  type = dmLONG;
 } else if ( cs_eq( typename, "f" ) ) {
  type = dmFLOAT;
 } else {
  itype = cmatch_c( typename, names, dmVOID+1 );
  if ( itype >= 0 ) type = types[itype];
 }
 return( type );
}

void dmASCDataTypeName( dmDataType type, char* typename )
{
 int itype;
 char* names[] = { "s", "i", "r", "d", "c", "br", "q", "ub", "us", "ul", " " };
 itype = (int)type;
 if ( itype < 0 || itype > 10 ) itype = (int)dmVOID;
 cs_copy( names[itype], typename );
}


