#ifndef STORE_H
#define STORE_H

typedef enum { dtVoid, dtDouble, dtReal, dtInt, dtChar, dtLogical } dtDataType;

#define MAXSTORE 50
typedef struct {
  long n[MAXSTORE];
  dtDataType type[MAXSTORE];
  long nmax[MAXSTORE];
  void* buf[MAXSTORE];
  char* base[MAXSTORE];
  char* top[MAXSTORE];
  long bytes[MAXSTORE];
  int ns;
  int index[6];
} Store;

void store_list_i( Store* store );
void store_list_q( Store* store );
void store_list_r( Store* store );
void store_list_c( Store* store );
void store_list_d( Store* store );
void store_list( Store* store );
void store_free( Store* store );
Store* store_alloc( void );
logical* store_alloc_q( Store* store, int n );
logical* store_q( Store* store, logical* x, int n );
void store_free_q( Store* store );
char** store_alloc_c( Store* store, int n, int ncp );
char** store_c( Store* store, char* x );
void store_free_c( Store* store );
real* store_alloc_r( Store* store, int n );
real* store_r( Store* store, real* x, int n );
void store_free_r( Store* store );
long* store_alloc_i( Store* store, int n );
long* store_i( Store* store, long* x, int n );
void store_free_i( Store* store );

double* store_alloc_d( Store* store, int n );
double* store_d( Store* store, double* x, int n );
void store_free_d( Store* store );

#endif
