#include <termios.h>
#include "jcmlib.h"
#include "jcmp.h"


static struct termios termios_arg;


integer ccio_get( integer fd, char* ptr, integer* fptr )
{
 integer i;
 (void)tcgetattr( fd, &termios_arg );

/* Save initial values */

 for ( i = 0; i < NCCS; i++ ) {
  *ptr++ = termios_arg.c_cc[i];
 }
 *ptr++ = termios_arg.c_cc[VMIN];
 *ptr++ = termios_arg.c_cc[VTIME];
 *fptr++ = (integer) termios_arg.c_iflag;
 *fptr++ = (integer) termios_arg.c_oflag;
 *fptr++ = (integer) termios_arg.c_cflag;
 *fptr++ = (integer) termios_arg.c_lflag;
 return( NCCS );
}


void ccio_set( integer fd, char* ptr, integer* fptr )
{
 integer i;

 for ( i = 0; i < NCCS; i++ ) {
  termios_arg.c_cc[i] = *ptr++;
 }
 termios_arg.c_iflag = (unsigned int)*fptr++;
 termios_arg.c_oflag = (unsigned int)*fptr++;
 termios_arg.c_cflag = (unsigned int)*fptr++;
 termios_arg.c_lflag = (unsigned int)*fptr++;

 (void)tcsetattr(fd,TCSADRAIN,&termios_arg);
}


void ccio_set_raw( char* ptr, integer* fptr )
{
/* Set raw mode values */
 fptr[0] = ~( INLCR | ICRNL );
 fptr[3] = ~( ICANON | ECHO );
 ptr[VMIN] = 1;
 ptr[VTIME] = 0;
 ptr[VSUSP] = -1;
}

