#include <math.h>
#include "jcmlib.h"


static const double d_2pi = 2.0 * M_PI;
static const real r_2pi = 2.0 * M_PI;
static const double d_circle = 360.0;
static const real r_circle = 360.0;
static const double deg_rad = 2 * M_PI / 360.0;
static const real r_deg_rad = 2 * M_PI / 360.0;

real radin_r( const real x ) 
{
 return( x * r_deg_rad );
}

real radout_r( const real x )
{
 return( x / r_deg_rad );
}

double radin_d( const double x ) 
{
 return( x * deg_rad );
}

double radout_d( const double x )
{
 return( x / deg_rad );
}



double circ_d( const double x )
{
 return( modulo_d( x, d_circle ) );
}


real circ_r( const real x )
{
 return( modulo_r( x, r_circle ) );
}

real circ_ew_r( const real x )
{
 real y;
 y = modulo_r( x, r_circle );
 if ( y >= r_circle/2 ) y -= r_circle;
 return( y );
}

double circ_ew_d( const double x )
{
 double y;
 y = modulo_d( x, d_circle );
 if ( y >= d_circle/2 ) y -= d_circle;
 return( y );
}


double circ_rad_d( const double x )
{
 return( modulo_d( x, d_2pi ) );
}


real circ_rad_r( const real x )
{
 return( modulo_r( x, r_2pi )  );
}

real circ_ew_rad_r( const real x )
{
 real y;
 y = modulo_r( x, r_2pi );
 if ( y >= M_PI ) y -= r_2pi;
 return( y );
}

double circ_ew_rad_d( const double x )
{
 double y;
 y = modulo_d( x, d_2pi );
 if ( y >= M_PI ) y -= d_2pi;
 return( y );
}



real argd_r( const real x, const real y )
{
 real a;
 if ( x == 0.0 && y == 0.0 ) {
  a = 0.0;
 } else {
  a = atan2( y, x ) / r_deg_rad;
  a = circ_r( a );
 }
 return( a );
}


double argd_d( const double x, const double y )
{
 double a;
 if ( x == 0.0 && y == 0.0 ) {
  a = 0.0;
 } else {
  a = atan2( y, x ) / deg_rad;
  a = circ_d( a );
 }
 return( a );
}


