#include <stdlib.h>
#include "jcmlib.h"




logical clip_r( const real x, const real y, const real x1, const real x2, const real yy1, const real yy2 )
{
 return(  x >= x1 && x <= x2 && y >= yy1 && y <= yy2 );
}
logical clip_d( const double x, const double y, const double x1, const double x2, const double yy1, const double yy2 )
{
 return(  x >= x1 && x <= x2 && y >= yy1 && y <= yy2 );
}

double rlap_check_d( const double x, const double yy1, const double yy2, logical* left, logical* right )
{
 double u;
 *left = x < yy1;
 *right = x > yy2;
 u = *left  ? yy1 : ( *right ? yy2 : x );
 return( u );
}
real rlap_check_r( const real x, const real yy1, const real yy2, logical* left, logical* right )
{
 real u;
 *left = x < yy1;
 *right = x > yy2;
 u = *left  ? yy1 : ( *right ? yy2 : x );
 return( u );
}

logical overlap_r( const real x1, const real x2, const real yy1, const real yy2,
    real* u1, real* u2 )
{
 logical left1, left2, right1, right2;

 *u1 = rlap_check_r( x1, yy1, yy2, &left1, &right1 );
 *u2 = rlap_check_r( x2, yy1, yy2, &left2, &right2 );
 return( !( right1 || left2 ) );
}

logical overlap_d( const double x1, const double x2, const double yy1, const double yy2,
    double* u1, double* u2 )
{
 logical left1, left2, right1, right2;

 *u1 = rlap_check_d( x1, yy1, yy2, &left1, &right1 );
 *u2 = rlap_check_d( x2, yy1, yy2, &left2, &right2 );
 return( !( right1 || left2 ) );
}


