#include <stdio.h>
#include "jcmlib.h"
#include "fio_file.h"
/*----------------------------------------------------------------------*/
/*
 * fio_open_list
 *
 * List all open files
 * Uses:
 *  <stdio.h>: sprintf
 *  csproto.h: cs_copy
 *  fileproto.h: fio_file_name, fio_get_type, fio_file_status fio_file_n
 *  msg
 */

void fio_list( void ) {
 integer n;
 integer file_no;
 t_filename name;
 t_word type;
 integer status;
 t_buf buf;
 t_word eof;
 logical qopen;
 integer pos, line, recl;
 integer istatus;
 integer cfd;
 n = fio_file_n();
 msg( " " );
 dashline( 40 );
 msg( " JCMLIB File IO System (FIO) Status " );
 dashline( 40 );
 msg( "  File  FD  Line  Cpos  Recl  IOS  EOF  Type        Name " );
 for ( file_no = 1; file_no <= n; file_no++ ) {
  fio_get_name( file_no, name, FSIZE );
  fio_get_type( file_no, type, WSIZE );
  cfd = fio_get_cfd( file_no );
  status = fio_status( file_no, 1 );
  qopen = status != FILE_CLOSED;
  if ( qopen ) {
   line = fio_get_lineno( file_no );
   pos  = fio_get_pos( file_no );
   recl = fio_get_recl( file_no );
   if ( status == FILE_EOF ) {
    istatus = -1;
    cs_copy( "EOF", eof );
   } else {
    istatus = 0;
    cs_copy( " ", eof );
   }
   sprintf( buf, "  %-6ld%-4ld%-6ld%-6ld%-6ld%-6ld%-4s%-12s%s",
    (long)file_no, (long)cfd, (long)line, (long)pos, (long)recl, (long)istatus, eof, type, name );
   msg( buf ); 
  }
 }
}




