/*======================================================================*/
/*
 *    cs2
 *
 *    Null terminated string ("C string") handling routines
 *
 */
/*======================================================================*/
#include <string.h>
#include <ctype.h>
#include "jcmlib.h"

/*----------------------------------------------------------------------*/
/*    cs_mmatch
 *    
 * Match at least n chars on template.
 * The buf must consist of the template plus optional
 * trailing characters.
 * 1996 Sep 30 JCM
 * Obsolete routine, see cs_eq_siz
 */

logical cs_mmatch( const char* template, const char* buf, const integer m )
{
 integer n = m;
 while ( n-- ) {
  if ( *template == '\0' ) return( TRUE );
  if ( *buf == '\0' ) return( cs_is_blank( template ) );
  if ( *template != *buf ) return( FALSE );
  template++;
  buf++;
 }
 return( TRUE );
}
/*----------------------------------------------------------------------*/
/*    cs_strpak
 *    
 * Pack a string, forcing to uppercase and removing spaces and underbars.
 * Useful for name resolvers.
 * 1996 Sep 30 JCM
 */

void cs_strpak( const char* source, char* dest )
{
 while ( *source != '\0' ) {
  while ( *source == ' ' || *source == '_' ) source++;
  if ( *source !='\0' ) *dest++ = toupper( *source++ );
 }
 *dest = '\0';
}

/*----------------------------------------------------------------------*/
/*
 *+cs_gparen
 *
 */

void cs_gparen( const char* source, const char lpar, const char rpar, char* dest )
{
 integer k;
 *dest++ = lpar;
 k = cs_ends( source );
 while ( k-- ) { *dest++ = *source++; }
 *dest++ = rpar;
 *dest   = '\0';
}

/*----------------------------------------------------------------------*/
/*
 *+cs_paren
 *
 */
char* cs_paren( const char* source, char* dest )
{
 cs_gparen( source, '(', ')', dest );
 return( dest );
}

/*----------------------------------------------------------------------*/
/*
 *+cs_sparen
 *
 */
char* cs_sparen( const char* source, char* dest )
{
 cs_gparen( source, '[', ']', dest );
 return( dest );
}


void cs_ubar( char* source )
{
 integer n;
 n = cs_ends( source );
 while ( n-- ) {
  if ( *source == ' ' ) *source = '_';
  source++;
 } 
}

void cs_deubar( char* source )
{
 integer n;
 n = cs_ends( source );
 while ( n-- ) {
  if ( *source == '_' ) *source = ' ';
  source++;
 } 
}

logical cs_nullstr( const char* source )
{
 return( *source == '\0' );
}



void cs_deparen( char** buf, char* dest )
{
 char* ptr;
 const char lpar = '(';
 const char rpar = ')';
 integer b,e;
 integer npar;

 npar = 1;
 ptr = *buf;
 b = cs_begs( ptr );
 e = cs_ends( ptr );
 ptr += b - 1;
 if (*ptr == lpar ) ptr++;
 while ( npar > 0 && ptr - *buf + 1 <= e  ) {
  if ( *ptr == lpar ) {
   npar++;
  } else if ( *ptr == rpar ) {
   npar--;
  }
  if ( npar > 0 ) { *dest++ = *ptr++; }
 }
 
 if ( npar > 0 ) { 
  *buf = NULL;
  *dest = '\0';
 } else {
  *buf =++ptr;
  *dest = '\0';
 }  
}


