#include "jcmlib.h"


/*
 *   cs_split_string
 * 
 *   Split a string into two parts. 
 *   Takes a string of the form aaasbbb, where s is a separator character,
 *   and returns two strings aaa and bbb, each null terminated.
 *   If the separator is not present, the first output string contains the whole
 *   input and the second string is null. The function returns true if the separator
 *   is found.
 *
 *   1996 Aug 26 JCM
 *   Args:
 *	buf		(i)	Input string
 *	sep		(i)	Separator char
 *	buf1		(o)	String before separator
 *	buf2		(o)	String after separator.
 */

logical cs_split_string( const char* buf, const char sep, char* buf1, char* buf2 )
{
 const char* ptr;
 logical status ;

 status = FALSE;
 ptr = buf;
 while ( *ptr != sep && *ptr != '\0' ) 
  *buf1++ = *ptr++;
 if ( *ptr++ != '\0' ) {
  status = TRUE;
  while ( *ptr != '\0' ) *buf2++ = *ptr++;
 }
 *buf1 = '\0';
 *buf2 = '\0';
 return( status );
}





