#include "jcmlib.h"


/*----------------------------------------------------------------------*/
/*
 *+cs_list_add
 *
 *
 *  Add an entry 'item' to a list of strings and return its number in the list.
 *  If item is already in the list, return its number, i.
 *  If it is not already in the list, add it to the end of the list,
 *  increment list_size, and return its number i = list_size.
 *  The number in the list is counted from 1, so item = list[i-1].
 */
integer cs_list_add( char** list, integer* list_size, const integer max_size, const char* item )
{
 integer item_no;

 item_no = match_c( item, list, *list_size );
 if ( item_no == 0 ) {
  if ( *list_size >= max_size ) {
   tmsg( "Routine list_add: list overflow" );
  } else {
   (*list_size)++;
   item_no = *list_size;
   cs_copy( item, list[item_no-1] );
  }
 }
 return( item_no );
}



