/*======================================================================*/
/*
 *   cs op
 *
 *   C string routines to manipulate strings
 *
 *
 */
/*======================================================================*/
#include "jcmlib.h"

/*----------------------------------------------------------------------*/
/*
 *   cs_lt
 *
 *   Test for string A < string B, up to trailing spaces.
 *   (Note that strcmp cares about trailing spaces and we don't.)
 *   1996 Aug 29 JCM
 *   Args:
 *	buf1		(i)	String A
 * 	buf2		(i)	String B
 */

logical cs_lt( const char* buf1, const char* buf2 )
{
 while( *buf1 == *buf2 && *buf1 != '\0' )  {
  buf1++;
  buf2++;
 }
 if ( *buf1 == '\0' ) return( !cs_is_blank( buf2 ) );
 if ( *buf2 == '\0' ) return( FALSE );
 return( *buf1 < *buf2 );
}

/*----------------------------------------------------------------------*/
/*
 *   cs_gt
 *
 *   Test for string A > string B, up to trailing spaces.
 *   (Note that strcmp cares about trailing spaces and we don't.)
 *   1996 Aug 29 JCM
 *   Args:
 *	buf1		(i)	String A
 * 	buf2		(i)	String B
 */

logical cs_gt( const char* buf1, const char* buf2 )
{
 while( *buf1 == *buf2 && *buf1 != '\0' )  {
  buf1++;
  buf2++;
 }
 if ( *buf1 == '\0' ) return( FALSE );
 if ( *buf2 == '\0' ) return( !cs_is_blank( buf1 ) );
 return( *buf1 > *buf2 );
}


