#include <string.h>
#include "jcmlib.h"

/*----------------------------------------------------------------------*/
/*
 * jcm_init
 *
 */
void sys_os( char* sysos )
{
#if (OS_SUN )
 cs_copy( "Solaris", sysos );
#else
 cs_copy( "Linux", sysos );

#endif
}


/*----------------------------------------------------------------------*/
/*
 * jcm_cmdlineargs
 * Uses csproto.h
 */

void jcm_cmdlineargs( integer argc, char **argv, card *args, integer* nargs, integer asiz )
/*
 * Parse command line arguments in JCMLIB style 1 (space separated).
 * Returns program name in args[0]
 * Returns arguments in args[i]
 * Returns number of args in nargs (must declare args[nargs+1])
 */

{
 *nargs = -1;
 if ( !asiz ) return;
 while ( argc-- ) {
 /*   argv is p p char, pointer to a particular string
     *argv is p char, a particular string
    **argv is  char, a single character in the string.
    Incrementing argv and args moves to the next string in the list.
  */
   cs_copy( *argv, *args );  
   argv++;
   args++;
   (*nargs)++;
 }
}

/*----------------------------------------------------------------------*/
/*
 * sys_filepath
 * Uses csproto.h tokenproto.h
 * Unix version only
 */

void sys_filepath( const char* dir, const char* name, const char* ext, char* buf, integer siz )
{
 if ( !cs_is_blank( dir ) && name[0] != '/' ) cs_put_token( dir, &buf, '/', &siz );
 if ( !cs_is_blank( name ) ) cs_put_cn( name, &buf, &siz );
 if ( !cs_is_blank( ext ) ) { cs_put_cn( ".", &buf, &siz ); cs_put_cn( ext, &buf, &siz ); }
 if ( siz ) *buf = '\0';
}

/*----------------------------------------------------------------------*/
/*
 * sys_pathstrip
 *
 * Remove leading directories from the path name. Unix only.
 */

void sys_pathstrip( const char* path, char* dir, char* name, const integer maxlen )
{
 char* ptr;
 integer len;
 ptr = strrchr( path, '/' );
 if ( ptr ) {
  len = min_i( ptr - path, maxlen );
  cs_copy_siz( path, dir, len );
  cs_copy_siz( ptr + 1, name, maxlen );
 } else {
  cs_copy_siz( path, name, maxlen );
 }
}
