#include <stdio.h>
#include "jcmlib.h"
static integer status = 0;
static card status_text;
static card status_code;
static t_buf savetree;

/*
 *--------------------------------------------------------------------------------
 */

void err_set( const integer code )
{
 status = code;
}

/*
 *--------------------------------------------------------------------------------
 */
integer err_get( void )
{
 return( status );
}

/*
 *--------------------------------------------------------------------------------
 */
void err_save( const char* code, const char* text )
{
 status = 1;
 cs_copy_siz( code, status_code, CSIZE );
 cs_copy_siz( text, status_text, CSIZE );
 dbg_fmttree( savetree, BSIZE );
}

/*
 *--------------------------------------------------------------------------------
 */
void err_disp( const integer mode )
{ 
 card buf;
 if ( status !=0 || !cs_is_blank( status_code ) ) {
  sprintf( buf, "Error status code %-6ld%s %s", 
   (long)status, status_code, status_text );
  jcm_err_msg( buf );
  if ( !cs_is_blank( savetree ) ) jcm_err_msg( savetree );
  if ( mode == 0 ) err_clear();
 }
}

/*
 *--------------------------------------------------------------------------------
 */
void err_save_io( const char* code, const char* text, const integer status_val )
{
 err_save( code, text );
 status = status_val;
}

/*
 *--------------------------------------------------------------------------------
 */
void err_clear( void )
{
 status = 0;
 cs_zero( status_text );
 cs_zero( status_code );
}

/*
 *--------------------------------------------------------------------------------
 */
logical err_test( const integer mode )
{
 logical q;
 q = (status!=0);
 if ( mode == 0 ) status = 0;
 return( q );
}



