#include "jcmlib.h"

/*
 *  F90 string routines
 */

char* adjustl( const char* a, char* b, const integer width )
{
 while( *a == ' ' ) { a++; }
 cs_copy_siz( a, b, width );
 return( b );
}

char* adjustr( const char* a, char* b, const integer width )
{
 integer leading_spaces;
 char* p;
 integer w;
 p = b;
 if ( cs_is_blank( a ) ) {
  w = width;
  while ( w-- ) { *p++ = ' '; }
  *p = '\0';
 } else {
  leading_spaces = width - cs_ends( a );
  while( leading_spaces-- ) { *p++ = ' '; }
  cs_copy( a, p );
 }
 return( b );
}

integer len_trim( const char* a )
{
 integer width;

 width = 0;
 if ( !cs_is_blank( a ) ) {
  width = strlen( a );
  while( a[width-1] == ' ' ) width--;
 }
 return( width );
}

/*
 *  Returns the number within set of the character in a.
 */
integer scan( const char* a, const char* set )
{
 integer i;
 integer m;

 m = strlen(a);
 for ( i = 0; i<m; i++ ) {
  if ( cs_ss_char( set, a[i] ) ) return( i+1 );
 }
 return( 0 );
}


integer verify( const char* a, const char* set )
{
 integer m;
 integer i;
 m = strlen(a);
 for ( i = 0; i<m; i++ ) {
  if ( !cs_ss_char( set, a[i] ) ) return( i+1 );
 }
 return( 0 );
}

char* repeat( const char* a, const integer ncopies, char* result, const integer width )
{
 integer copy;
 integer pos1, pos2;

 cs_copy( " ", result );
 if ( ncopies > 0 ) {
  for ( copy = 0; copy < ncopies; copy++ ) {
   pos1 = copy * width + 1;
   pos2 = (copy+1) * width + 1;
   cs_put_ss( a, result, pos1, pos2 );
  }
  result[ ncopies*width ] = '\0';
 }
 return( result );
}


