#include <stdio.h>
#include "jcmlib.h"


void eflag_list( char** efln, logical* eflags, char** evals, integer neflags, char* cmt, integer tab )
{
 t_buf buf;
 char* ptr;
 integer siz;
 integer ktab;
 card ecmt;
 t_word fmt;
 const integer tab0 = 38;
 logical none;
 integer i;

 none = TRUE;
 siz = BSIZE;
 if ( tab == 0 ) {
  ktab = cs_ends( cmt ) + 1;
 } else if ( tab < 0 ) {
  ktab = tab0;
 } else {
  ktab = tab;
 }
 cs_copy_siz( cmt, ecmt, ktab );
 sprintf( fmt, "%%-%lds", (long)ktab );
 sprintf( buf, fmt, ecmt );
 ptr = buf + ktab - 1;
 for ( i = 0; i < neflags; i++ ) {
  if ( eflags[i]  ) {
   none = FALSE;
   cs_put_c( efln[i], &ptr, &siz );
   if ( !cs_is_blank( evals[i] ) ) {
    ptr--;
    *ptr++ = '=';
    cs_put_c( evals[i], &ptr, &siz );
   }
  }
 }
 if ( none ) cs_copy( "(none)", buf );
}


logical eflag_set( char* word, char* value, char** efln, 
 char** evals, integer neflags, logical* eflags, logical set )
{
 logical ok;
 integer i;
 ok= FALSE;
 for ( i = 0; i < neflags; i++ ) {
  if( cs_eq( word, efln[i] ) ) {
   eflags[i] = set;
   cs_copy( value, evals[i] );
   ok = TRUE;
  }
 }
 return( ok );
}


void eflag_parse( char** args, integer nargs, logical local_flag_set( char*, char*, logical ) )
{
 integer i;
 logical set;
 logical found;
 card word;
 card value;

 for ( i = 0; i < nargs; i ++ ) {
  set = eflag_syntax( args[i], word, value );
  found = local_flag_set( word, value, set );
  if ( !found ) jcm_err_msg1( "Flag not found: ", word );
 }
}


logical eflag_syntax( char* opt, char* word, char* value )
{
 logical set;
 integer j;
 if ( *opt == '+' ) {
  opt++;
  set = TRUE;
 } else if ( *opt == '-' ) {
  opt++;
  set = FALSE;
 } else {
  set = TRUE;
 }
 j = cs_index_char( opt, '=' );
 if ( j == 0 ) {
  cs_copy( opt, word );
  cs_copy( " ", value );
 } else {
  cs_copy_siz( opt, word, j-1 );
  cs_copy( opt + j, value );
 }
 cs_upper( word );
 return( set );
}
