#include <stdlib.h>
#include <stdio.h>
#include "jcmlib.h"

/*
 * Safe mem free
 */

void mfree( void* p )
{
 if ( p ) free( p );
}
/*
 * Allocate array of 3-vectors of length n 
 */

double** vec_alloc_d( const integer n )
{
 double* p;
 integer c;
 double** v;
 v = (double**)malloc( n * sizeof( double * ) );
 p = (double *) malloc( n * 3 * sizeof( double ) );
 for ( c = 0; c < n; c++ ) {
  v[c] = p + 3 * c;
  vzero_d( v[c] );
 }
 return( v );
}

/* Print a 3-vector */

char* vwritef_d( const double* p, const char* fmt, char* buf, const integer siz )
{
 card fbuf;
 card tbuf;
 sprintf( fbuf, "%s %s %s", fmt, fmt, fmt );
 sprintf( tbuf, fbuf, p[0], p[1], p[2] );
 cs_copy_siz( tbuf, buf, siz );
 return( buf );
}

char* vwritef_r( const real* p, const char* fmt, char* buf, const integer siz )
{
 card fbuf;
 card tbuf;
 sprintf( fbuf, "%s %s %s", fmt, fmt, fmt );
 sprintf( tbuf, fbuf, p[0], p[1], p[2] );
 cs_copy_siz( tbuf, buf, siz );
 return( buf );
}

char* vec_print_d( double* p, char* fmt, char* buf )
{
 card fbuf;
 sprintf( fbuf, "%s %s %s", fmt, fmt, fmt );
 sprintf( buf, fbuf, p[0], p[1], p[2] );
 return( buf );
}

/* Free an array of 3-vectors */

void vec_free_d( double** v )
{
 free( v[0] );
 free( v );
}


/* Test if a 3-vector is null */

logical vnull_d( const double* v )
{
 return( v[0] == 0.0 && v[1] == 0.0 && v[2] == 0.0 );
}

logical vnull_r( const real* v )
{
 return( v[0] == 0.0 && v[1] == 0.0 && v[2] == 0.0 );
}


/* 
 *  Rotate 2-D coordinates through a given angle.
 *  The angle is in degrees.
 */

void rotate2_d( const double x, const double y, const double roll, double* xx1, double* yy1 )
{
 *xx1 = x * dcosd( roll ) - y * dsind( roll );
 *yy1 = x * dsind( roll ) + y * dcosd( roll );
}


