#include <stdlib.h>
#include <stdio.h>
#include "jcmlib.h"
#include "jcmp.h"
#include "esc_types.h"


static logical Detab_Flag = TRUE;

/*----------------------------------------------------------------------*/
/*
 * esc_continue
 * 
 */

static logical esc_continue( char** ptr, char cont_char, char esc_char )
{
 integer j;
 char* buf;
 buf = *ptr;
 j = strlen( buf );
 if( buf[j-1] == cont_char ) {
  if( buf[j-2] == esc_char ) {
  /*  Escaped cont char */
   buf[j-2] = cont_char;
   buf[j-1] = 0;
  } else {
  /* Have a continuation */
   *ptr = &buf[j-1];
   return( TRUE );
  }
 }
 return( FALSE );
}

/*----------------------------------------------------------------------*/
/*
 * iofs_read
 * Uses csproto.h
 * Uses <stdlib.h>: system
 * Reads a line, handling continuations and removal of tabs, and
 * supporting system escapes.
 */


logical iofs_read( char* buf, char* prompt, integer siz )
{
 logical cont_trap;  /* Continuation lines */
 logical loop;     
 char sys_char, esc_char, cont_char;
 char* cmd;
 integer ios;

 sys_char = *esc_get_char( SYS_CHAR );
 esc_char = *esc_get_char( ESC_CHAR );
 cont_char = *esc_get_char( CONT_CHAR );
 iofs_set_input();

 loop = TRUE;
 while ( loop ) {
  if( io_int(0) ) { tmsgl( prompt ); tmsgl( ": "); }
  cont_trap = TRUE;
  cmd = buf;

  while( cont_trap && loop ) {
   ios = io_input( cmd, siz );
   loop = ios;
   if ( !loop ) dmsg( 1, "EOF FOUND ******" );
   if ( loop ) cont_trap = esc_continue( &cmd, esc_char, cont_char );
  } 

  /* end inner loop */
  /* OK we have a line including continuations */
  if ( *buf == sys_char ) {
   system( &buf[1] );
  } else {
   if ( buf[1] == esc_char && buf[2] == sys_char ) {
    cs_copy( &buf[1], buf );
   }
   loop = FALSE;
  } /* end if sys char test */
 } /* end outer loop */
 if ( Detab_Flag ) cs_detab( buf );
 return( ios );
}




void iofs_detab( logical q )
{
 Detab_Flag = q;
}


