void sys_cmdline( char** args, integer nargs, char* cmdline, integer siz );
/*
 *   Internal routine used in TPIO
 */

void cheapsort_d( const double* x, const integer n, integer* jsort );	/* Use heapsort algorithm */
void cheapsort_i( const integer* x, const integer n, integer* jsort );
void cheapsort_c( char** x, const integer n, integer* jsort );
void cheapsort_r( const real* x, const integer n, integer* jsort );	/* Use heapsort algorithm */
void cheapsort_s( const short* x, const integer n, integer* jsort );
void cshellsort_d( const double* x, const integer n, integer* jsort );	/* Use shellsort algorithm */
void cshellsort_i( const integer* x, const integer n, integer* jsort );
void cshellsort_c( char** x, const integer n, integer* jsort );
void cshellsort_r( const real* x, const integer n, integer* jsort );	/* Use shellsort algorithm */
void cshellsort_s( const short* x, const integer n, integer* jsort );

void heapsort_d( const double* x, const integer n, integer* jsort );	/* Use heapsort algorithm */
void heapsort_i( const integer* x, const integer n, integer* jsort );
void heapsort_c( char** x, const integer n, integer* jsort );
void shellsort_d( const double* x, const integer n, integer* jsort );	/* Use shellsort algorithm */
void shellsort_i( const integer* x, const integer n, integer* jsort );
void shellsort_c( char** x, const integer n, integer* jsort );
void heapsort_r( const real* x, const integer n, integer* jsort );	/* Use heapsort algorithm */
void heapsort_s( const short* x, const integer n, integer* jsort );
void shellsort_r( const real* x, const integer n, integer* jsort );	/* Use shellsort algorithm */
void shellsort_s( const short* x, const integer n, integer* jsort );
/*
 *   As the above csort rotines, but using specific algorithms.
 */

integer cio_open( char* filename, char* jmode, char* mode );
void cio_setup_raw( integer fid );
void cio_set_raw( integer fid );
void cio_clear_raw( integer fid );
void ccio_set( integer fid, char* ptr, integer* fptr );
integer ccio_get( integer fid, char* ptr, integer* fptr );
void ccio_set_raw( char* ptr, integer* fptr );

void sys_byte_d( const integer byte, integer* segment, integer* ibyte );
char esc_special_char( const integer type );
/*
 *  Convert enum to char
 */
char* esc_get_char( integer type );							/* Get given ESC char */
void esc_get_struct( integer type, char* echar, char* edefault, char* name );	/* Access ESC structure */

void unit_si_resolve( integer n, char** unit, integer* fac );
void unit_compose( char** base_unit, double* exp_unit, integer* si_fac, integer n_uo, logical texmode, char* unit, integer siz );
void unit_compitem( char** ptr, char* item, double exp_unit, integer si_fac, integer* siz );
void unit_parse_mantissa( char* base_unit, double* exp_unit );
void unit_parse_exp( const char* unit_item, char* base_unit, double* exp_unit );
void unit_parse( const char* unit, integer* n_uo, char** base_unit, double* exp_unit, integer* si_factor );
void unit_tmult( integer* n1, char** base1, double* exponent1, integer* si_fac1,
                 integer* n2, char** base2, double* exponent2, integer* si_fac2, integer power );

void si_tmult( integer fac1, double exponent1, integer fac2, double exponent2, integer* fac, double* mantissa );
integer si_eval_r( real x );
integer si_eval_d( double x );
void si_calc_d( double x, double* y, char* pfx, integer* exponent, char* mode );
void si_calc_r( real x, real* y, char* pfx, integer* exponent, char* mode );
void si_check( char* unit, integer* factor, integer* pos );

void jcmlib_layer1_init( void );

extern integer fio_alloc( void );
/*
 *   Allocate a new FIO handle
 */

void fio_apply_path( const char*, char*, integer );
/*
 *  Apply current working directory to file.
 */
integer fio_open_file( const char* filename, char* mode, integer rec_bytes );
integer fio_open_retry( const char* filename, char* mode, integer rec_bytes );
void fio_set_status_pos ( integer fid, logical ios, integer pos ) ;
integer fio_terminate_buf( integer pos, const char* buf, char* buf2, logical strip, logical nl, integer siz );
void fio_set_eof( integer file );			/*  Set file EOF condition */
void fio_file_clear( integer file_no ) ;		/*  Free entry in file list */
integer fio_cfile_alloc( char* Name, char* Type, integer fd );
void fio_set_type( integer fid, char* type );
void fio_set_pos( integer fid, integer pos );
void fio_delta_pos( integer fid, integer pos );
void fio_line_reset( integer fid );
void pager_tty_io( void );
logical fio_inquire_path( char* name, char* pathname, integer siz );

void fio_change_dir( char* dir );
/*
 * Obsolete
 * Change the current working directory for FIO opens.
 * The directory will be prepended to any relative pathname you
 * try and open.
 */

void fio_get_dir( char* dir );
/*
 *  Get the current working directory. -obsolete
 */
extern void iofs_set_input( void );
extern void io_iclear( void );
extern void iofs_get_entry( char* io_type, integer level, char* buf, integer* fid, char* status );
extern void iofs_print_top( char* type, char* pfx );
extern void iofs_print_stack( char* type, integer top );

logical tpio_getbuf( char* prompt );					/* Read in new buffer */
void tpio_cclear( integer level );
void tpio_token( char* prompt, integer mode, char* token, integer siz ); /* Return token, reading new buffer if needed */
void loop_echo( void );
void loop_end( void );
void loop_do( void );
void loop_goto( integer );
void tpio_out( char* buf, logical append, logical syserr );					/* Set log file */
extern void tpio_cc_esc( char* ecmd, char* prompt, logical* eot,  logical* found_esc, char* buf, integer siz );
extern void tpio_cc_start_check( char* buf, logical* mode );
extern void tpio_cc_cmd( char* prompt, logical* mode, char* buf, integer siz );
extern void tpio_cc_check( char* prompt, logical* eot, logical* found_esc, char* buf, integer siz );
extern void tpio_cc_esc( char* ecmd, char* prompt, logical* eot,  logical* found_esc, char* buf, integer siz );



