#include <stdio.h>
#include <string.h>
#include "jcmlib.h"
#include "jcmp.h"
#include "fio_file.h"

static integer pager_nlines = 40;
static integer pager_line = 0;
static logical pager_quiet = FALSE;
static logical pager_on = FALSE;


void pager_print_state( void )
{
 card buf;
 integer last_line;
 t_word state;

 last_line = pager_line;
 if ( pager_on ) {
  if ( pager_quiet ) {
   cs_copy( "Quiet", state );
  } else {
   cs_copy( "Active", state );
  }
 } else {
  cs_copy( "Off", state );
 }
 sprintf( buf, " Pager status:       %s", state ); msg( buf );
 sprintf( buf, " Pager page size:    %ld", (long)pager_nlines ); msg( buf );
 sprintf( buf, " Pager current line: %ld", (long)last_line );    msg( buf );
 sprintf( buf, " Pager new current line: %ld", (long)pager_line );    msg( buf );
 msg( " " );
}

void pager_set_length( integer page_length )
{
 pager_nlines = page_length;
}

void pager_set( logical q )
{
 pager_on = q;
 pager_quiet = FALSE;
}

logical tty_read( char* buf, integer siz )
{
 logical ios;
 ios = fio_get( 0, buf, siz );
 pager_line = 0;
 pager_quiet = FALSE;
 return( ios );
}

logical tty_write( const char* buf )
{
 logical ios = TRUE;
 if ( ! pager_quiet ) {
  ios = fio_put( 0, buf, TRUE, TRUE );
  pager_line = ( pager_line + 1 ) % pager_nlines;
  if ( pager_on && pager_line == 0 ) pager_tty_io();
 }
 return( ios );
}

logical tty_writel( char* buf )
{
 logical ios = TRUE;
 if ( !pager_quiet ) {
  ios = fio_put( 0, buf, FALSE, FALSE );
 }
 return( ios );
}

void pager_tty_io( void )
{
 char c;
 printf( "--Press Return to Continue--" );
 c = getc( stdin );
 if ( c == 'q' || c == 'Q' ) pager_quiet = TRUE;
}

