#include "jcmlib.h"
#include "jcmp.h"

#define NPMAX 20
static integer npath = 0;
static char** path;

void fio_path_init( void )
{
 char pathlist[1024];
 path = alloc_array_c( FSIZE, NPMAX );
 npath = 0;
 sys_getenv( "JCMPATH", pathlist );
 fio_path_set( pathlist );
}

void fio_path_set( char* pathlist )
{
 integer i;
 t_filename tmp;
 npath = list_parse( pathlist, path, FSIZE );
 for ( i = 0; i < npath; i++ ) {
  if ( *(path[i]) == '$' ) {
   cs_copy( path[i], tmp );
   sys_getenv( tmp, path[i] );
  }
 }
}

void fio_path_list( void )
{
 integer i;
 msg( "JCMLIB directory search path:" );
 for ( i = 0; i < npath; i++ ) {
  msg( path[i] );
 }
}

logical fio_inquire_path( char* name, char* pathname, integer siz )
{
 logical q;
 integer i;
 t_filename tmp;
 cs_copy( name, pathname );
 q = fio_inquire( pathname );
 i = 0;
 if ( *name != '/' ) {
  while( !q && i < npath ) {
   sys_filepath( path[i++], name, " ", tmp, siz );
   q= fio_inquire( tmp );
   if ( q ) cs_copy( tmp, pathname );
  }
 }
 return( q );
}
