/* Emulate F90 date and time */
#include <time.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "jcmlib.h"
#include "jcmp.h"

void date_and_time( char* c_date, char* c_time, char* c_zone )
{
 struct tm *t;
 time_t now;
 t_word t_date;
 t_word t_time;
 t_word t_zone;

 now = time( (time_t *)NULL );
 t = localtime( &now );
 strftime( t_date, WSIZE, "%Y%m%d", t );
 strftime( t_time, WSIZE, "%H%M%S.000", t );
 strftime( t_zone, WSIZE, "%z", t );
 cs_copy( t_date, c_date );
 cs_copy( t_time, c_time );
 cs_copy( t_zone, c_zone );
}


void sys_today( char* buf, const integer size )
{
 struct tm *t;
 time_t now;
 now = time( (time_t *)NULL );
 t = gmtime( &now );
 strftime( buf, size,"%Y %b %d %H:%M:%S", t );
}

void sys_time( char* buf, const integer size )
{
 struct tm *t;
 time_t now;
 now = time( (time_t *)NULL );
 t = gmtime( &now );
 strftime( buf, size,"%H:%M:%S", t );
}


void sys_date( char* buf, const integer size )
{
 struct tm *t;
 time_t now;
 now = time( (time_t *)NULL );
 t = gmtime( &now );
 strftime( buf, size,"%d/%m/%y", t );
}

void sys_wait( const integer t )
{
 sleep( t );
}

void sys_getenv( const char* name, char* value )
{
 cs_copy( getenv( name ), value );
}

void sys_delete( const char* name )
{
 unlink( name );
}

void sys_cmdline( char** args, integer nargs, char* cmdline, integer csiz )
{
 integer i;
 char* ptr;
 integer siz;
 ptr = cmdline;
 for ( i = 1; i < nargs; i++ ) {
  siz = cs_ends( args[i] );
  siz = ( siz < csiz ) ? siz : csiz;
  if ( siz > 0 ) cs_copy_siz( args[i], ptr, siz );
  ptr += siz;
  *ptr++ = ' ';
  csiz -= siz+1;
 }
 *ptr = '\0';
}

void sys_type( const char* name )
{
 t_buf cmd;
 sprintf( cmd, "cat %s", name );
 system( cmd );
}

void sys( const char* cmd )
{
 system( cmd );
}


double sys_stamp( void )
{
 struct tm *t;
 time_t now;
 integer j, k;
 double ddate;
 now = time( (time_t *)NULL );
 t = gmtime( &now );
 j = t->tm_sec + 100 * ( t->tm_min + 100 * t->tm_hour );
 k = t->tm_mday + 100 * ( t->tm_mon + 100 * t->tm_year );
 ddate = k + ( (double)j / 1.0E6 );
 return( ddate );
}


void jcmlib_id( char* label, const char* ver )
{ 
 card cdate;
 sys_today( cdate, CSIZE );
 sprintf( label, "%s (%s)", cdate, ver );
}
