/*
 * Roman and Greek 
 */
#include "jcmlib.h"


static char* roman_data = "IVXLCDM";
static integer roman_val[] = { 1, 5, 10, 50, 100, 500, 1000 };
static const integer ngreek = 24;
static char* greek[] = { "Alpha", "Beta", "Gamma", "Delta", "Epsilon", 
 "Zeta", "Eta", "Theta", "Iota", "Kappa", "Lambda", "Mu", "Nu", "Xi",
 "Omicron", "Pi", "Rho", "Sigma", "Tau", "Upsilon", "Phi", "Chi", "Psi", "Omega" };

integer iroman( const char* buf )
{
 integer n;
 integer pos;
 const char* ptr;
 integer this_val;
 integer this_sign;
 integer big;
 integer right_val = 0;

 pos = cs_ends( buf );
 this_val = 1;
 big = 0;
 right_val = 0;
 n = 0;
 ptr = buf + pos - 1;
 this_sign = 1;

 while ( pos >= 1 && this_val != 0 )  {
  this_val = cs_index_char( roman_data, *ptr-- );
  if ( this_val > 0 ) {
   if ( this_val >= big ) {
    big = this_val;
    this_sign = 1;
   } else if ( this_val < right_val ) {
    this_sign *= -1;
   } else if ( this_val >= right_val ) {
/* Same as or bigger than one to its right */
    ;
   }
  }
  n += this_sign * roman_val[ this_val-1 ];
  right_val = this_val;
  pos--;
 }
 if ( big == 0 ) n = 0;
 return( n );
}


void croman( integer n, char* word )
{
 integer val;
 integer pos;
 integer rval;
 integer rem;
 integer val2;

 pos = 0;
 val = 6;
 while( val >= 0 ) {
  rval = roman_val[ val ];
  while( n >= rval ) {
   n -= rval;
   *word++ = roman_data[ val ];
  }
  if ( val > 0 ) {
   rem = rval - n;
   val2 = 2 * ( ( val - 1 ) / 2 );
   if ( rem <= roman_val[ val2 ] ) {
    n += roman_val[val2] - roman_val[val];
    *word++ = roman_data[ val2 ];
    *word++ = roman_data[ val ];
   }
  }
  val--;
 }
 *word = '\0';
}



integer igreek( const char* buf ) 
{
 t_word word; 
 cs_copy( buf, word );
 cs_mixcase( word );
 return( match_c( word, greek, ngreek ) );
}


void cgreek( const integer n, char* buf )
{
 if ( n > 0 && n <= ngreek ) {
  cs_copy( greek[n-1], buf );
 } else {
  cs_copy( " ", buf );
 }
}
