#include "jcmlib.h"
#include <stdio.h>
/*
 *+transfer_i
 *
 * Transfer data from storage of arbitrary type to integer array,
 * without conversion.
 *-
 */

void transfer_i( 
  void* source, 	/* Source storage */
  integer* dest, 		/* Destination storage */
  const integer dest_size 	/* Number of destination items to transfer */
 )
{
 char* ptr = (char *)source;
 char* dptr = (char *)dest;
 integer n = dest_size * 4;
 while( n-- )
 {
  *dptr++ = *ptr++;
 }
}

void transfer_r( void* source, float* dest, const integer dest_size )
{
 char* ptr = (char *)source;
 char* dptr = (char *)dest;
 integer n = dest_size * 4;
 while( n-- )
 {
  *dptr++ = *ptr++;
 }
}

void transfer_d( void* source, double* dest, const integer dest_size )
{
 char* ptr = (char *)source;
 char* dptr = (char *)dest;
 integer n = dest_size * 8;
 while( n-- )
 {
  *dptr++ = *ptr++;
 }
}

void transfer_s( void* source, short* dest, const integer dest_size )
{
 char* ptr = (char *)source;
 char* dptr = (char *)dest;
 integer n = dest_size * 2;
 while( n-- )
 {
  *dptr++ = *ptr++;
 }
}

void transfer_c( void* source, char* dest, const integer dest_size )
{
 char* ptr = (char *)source;
 integer n = dest_size;
 while( n-- )
 {
  *dest++ = *ptr++;
 }
}

