#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "jcmlib.h"
#include "jcmp.h"
#include "unit.h"

#define USIZE 20
static t_unit* ureg1;
static t_unit* ureg2;



static integer nudf;
static char** udf_unit;
static char** udf_def;
#define NUDF 100


void unit_si_resolve( const integer n, char** unit, integer* fac )
{
 integer i;
 integer factor, pos;
 integer j;
 t_word temp;

 if ( nudf == 0 ) return;
 for ( i = 0; i < n; i++ ) {
  si_check( unit[i], &factor, &pos );
  if ( pos > 1 ) {
   cs_copy( unit[i] + pos - 1, temp );
   j = cmatch_c( temp, udf_unit, nudf );
   if ( j > 0 ) {
    cs_copy( temp, unit[i] );
    fac[i] += factor;
   }
  }
 }

}

void unit_def_read( const char* filename )
{
 integer in;
 integer n;
 t_buf line;
 char* ptr;

 if ( nudf == 0 ) {
  udf_unit = alloc_array_c( WSIZE, NUDF );
  udf_def  = alloc_array_c( WSIZE, NUDF );
 }
 n = 0;
 in = fio_open_r( filename );
 if ( in > 0 ) {
/* Fixed bug 1997 Mar 12, fio read result is logical */
  while ( fio_read( in, line, BSIZE )  ) {
   cs_detab( line );
   if ( !cs_is_blank( line ) ) {
    ptr = line;
    cs_get_c( &ptr, udf_unit[n], WSIZE );
    if ( ptr != NULL ) {
     cs_copy( ptr, udf_def[n] );
    } else {
     cs_copy( " ", udf_def[n] );
    }
    n++;
   }
  }
 }
 nudf = n;
 fio_close( in );
}


void unit_init( void )
{
 ureg1 = alloc_unit( USIZE );
 ureg2 = alloc_unit( USIZE );
}


void unit_dparse( const char* u1, char* u2, const integer siz )
{
 unit_regparse( u1, ureg1 );
 unit_ddisp( ureg1 );
 unit_regcompose( ureg1, u2, siz );
}

void unit_resolve( const char* u1, char* u2, const integer siz )
{
 unit_regparse( u1, ureg1 );
 unit_ddisp( ureg1 );
 unit_regresolve( ureg1, ureg2, udf_unit, udf_def, nudf );
 unit_regdedup( ureg1, ureg2 );
 unit_regcompose( ureg1, u2, siz );

}


void unit_mult( const char* u1, const char* u2, char* u, const integer siz )
{
 unit_regparse( u1, ureg1 );
 unit_regparse( u2, ureg2 );
 unit_ddisp( ureg1 );
 unit_ddisp( ureg2 );
 unit_regmult( ureg1, ureg2, +1 );
 unit_ddisp( ureg1 );
 unit_regcompose( ureg1, u, siz );
}


void unit_div( const char* u1, const char* u2, char* u, const integer siz )
{
 unit_regparse( u1, ureg1 );
 unit_regparse( u2, ureg2 );
 unit_ddisp( ureg1 );
 unit_ddisp( ureg2 );
 unit_regmult( ureg1, ureg2, -1 );
 unit_ddisp( ureg1 );
 unit_regcompose( ureg1, u, siz );
}


void unit_exp( const char* unit1, const double power, char* unit2, const integer siz )
{
 unit_regparse( unit1, ureg1 );
 unit_regexp( ureg1, power );
 unit_regcompose( ureg1, unit2, siz );

}


