#include <stdio.h>
#include "jcmlib.h"
#include "jcmp.h"

#define NVER 40

integer nver = 0;
char** program = NULL;
char** version;

logical ver_init( const char* prog, const char* ver )
{
 integer i;
 card buf;

 if ( program == NULL ) {
  program = alloc_array_c( CSIZE, NVER );
  version = alloc_array_c( WSIZE, NVER );
  nver = 0;
 }
 i = cmatch_c( prog, program, nver );
 if ( i >= 0  ) {
  if ( !cs_eq( ver, version[i] ) ) jcm_err_msg1( "JCMLIB WARNING: Package version mismatch ", prog );
  return( TRUE );
 } else {
  if ( nver < NVER-1 ) nver++;
  i = nver - 1;
  cs_copy( prog, program[i] );
  cs_copy( ver, version[i] );
  sprintf( buf, "Init %s %s\n", prog, ver );
  dmsg( 1, buf );
  return( FALSE );
 }
}

void ver_msg( void )
{
 card buf;
 integer i;
 for ( i = 0; i < nver; i++ ) {
  sprintf( buf, "%s %s", program[i], version[i] );
  msg( buf );
 }
}

void jcmlib_ver( char* ver, const integer maxlen )
{
 cs_copy_siz( JCMLIBVER, ver, maxlen );
}

void jcmlib_init( void )
{
 if ( !ver_init( JCMLIB, JCMLIBVER ) ) {
  jcmlib_layer1_init();
  sys_rand_init();
 }
}
